Ext.BLANK_IMAGE_URL = '/toscawidgets/resources/tw.extjs/static/resources/images/default/s.gif';

// Option to offer virtual board passed by the widget
var offerVirtualBoards = $offerVirtualBoards;
// Flag to tell if the gateway is started in command line or by a service
var isGatewayInCLI = $isGatewayInCLI;
if( !Ext.isIE ) {
  Paraxip.console.debug('Virtual boards will be offered: ' + 
      offerVirtualBoards);
  Paraxip.console.debug('Is the gateway started in command line: ' +
                        isGatewayInCLI);
}

Ext.onReady(function() {
  Ext.namespace('Paraxip.mainTabPanel');
  Paraxip.mainTabPanel.isGatewayStarted = false;
  Paraxip.mainTabPanel.previousGWStatus = false; //Keep trace of the old status. Only for routing rules tab.
  Paraxip.mainTabPanel.configFileExists = false;

  Paraxip.mainTabPanel.changeConfigTabDisplay = function(activeTab) {
    Paraxip.config.routingRules.getRoutingRules();
  };

  Paraxip.mainTabPanel.synchText = {
    id      : "Paraxip.mainTabPanel.synchText",
    text    : '<html>Configuration Synched&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>', 
    iconCls : 'paraxip-synchconfig'
  };
  
  Paraxip.mainTabPanel.outOfSynchText = {
    id      : "Paraxip.mainTabPanel.outOfSynchText",
    text    : '<html>Configuration Out of Synch&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</html>', 
    iconCls : 'paraxip-outofsynchconfig'
  };

  //status check call back function
  Paraxip.mainTabPanel.gwStatusBar = new Ext.StatusBar({
    id          : 'gw_status_bar',
    height      : 27,
    hideBorders : true,
    style       : 'border: none; padding: 2px;',
    items       : []
  });

  Paraxip.mainTabPanel.configSynchStatusBar = new Ext.StatusBar({
    id              : 'config_synch_status_bar',
    height          : 27,
    defaultText     : '<html>Configuration Synched&nbsp;&nbsp;&nbsp;</html>',
    defaultIconCls  : 'paraxip-synchconfig',
    style           : 'border: none; padding: 2px;',
    items           : [
      //Paraxip.mainTabPanel.start_btn,
      //'-',
      //Paraxip.mainTabPanel.stop_btn
    ]
  });

  Paraxip.mainTabPanel.gwStatusBar.setStatus(Paraxip.downStatus);

  Ext.QuickTips.init();

  //Create Status Bar
  Paraxip.mainTabPanel.tabPanel = new Ext.TabPanel({
    id                : 'mainTabPanel',
    width             : $width,
    height            : $height,
    renderTo          : "$renderTo",
    deferredRender    : false,
    frame             : $frame,
    layoutOnTabChange : false,
    autoScroll        : $autoScroll,
    bbar              : [
      Paraxip.mainTabPanel.gwStatusBar,
      '->',
      Paraxip.mainTabPanel.configSynchStatusBar
    ]
  });

  var items = $items;

  var itemIndex;

  for (itemIndex in items) {
    if (itemIndex < items.length) {
      var item = items[itemIndex];
      item.layout = 'fit';
      if( item.id != 'statusControlTabId') {
        item.hideMode = 'offsets';
      }
      Paraxip.mainTabPanel.tabPanel.add(item);
    }
  }

  Paraxip.mainTabPanel.tabPanel.getItem("wizardTabId").add(wizard);
  Paraxip.mainTabPanel.tabPanel.getItem("configTabId").add(configTabPanel);
  Paraxip.mainTabPanel.tabPanel.getItem("statusControlTabId").add(Paraxip.status.statusTabPanel);
  Paraxip.mainTabPanel.tabPanel.getItem("fileBrowserTabId").add(Paraxip.fileBrowser.fileBrowserTabPanel);
  Paraxip.mainTabPanel.tabPanel.doLayout();
  Paraxip.mainTabPanel.tabPanel.setActiveTab('$activeTab');
  Ext.Ajax.request({
    url: "/configFileExist",
    disableCaching: true,
    success: function (result, request)
    {
      var response = Ext.util.JSON.decode(result.responseText);
      if (!response.configFileExist) {
        Paraxip.mainTabPanel.tabPanel.setActiveTab('wizardTabId');
      } else {
        Paraxip.mainTabPanel.configFileExists = true;
        Paraxip.mainTabPanel.tabPanel.setActiveTab('statusControlTabId');
      }
    }
  });
  Ext.Ajax.request({
    url: "config/getIsConfigOutOfSynch",
    disableCaching: true,
    success: function (result, request)
    {
      var response = Ext.util.JSON.decode(result.responseText);
      if (!response.isConfigOutOfSynch) {
        Paraxip.mainTabPanel.configSynchStatusBar.setStatus(Paraxip.mainTabPanel.synchText);
      } else {
        Paraxip.mainTabPanel.configSynchStatusBar.setStatus(Paraxip.mainTabPanel.outOfSynchText);
      }
    }
  });


  Paraxip.mainTabPanel.tabPanel.on('tabchange', function(tabPanel, newTab) {
    Paraxip.isGwStartedCall();
    if( newTab.id == "configTabId") {
      if( newTab.layout.activeItem !== null && newTab.layout.activeItem.getId() == "pstnEditorTabId") {
        //Call the reloadTree(false) method from editor.js file
        reloadTree(false);
      }
      Paraxip.mainTabPanel.changeConfigTabDisplay(newTab);
    }
  });
  
  // This task manager tells the broser every minute to reload the
  // page if the selected tab is STATUS AND CONTROL and also to check
  // the status of the gateway to update the status bar.
  var task = {
    run: function() {
      Paraxip.isGwStartedCall();
    },
    interval: 60000 //1 minute
  };
  Ext.TaskMgr.start(task);

});

