//-----------------------------------------------
// Function used to disable/enable every button
// from a radiogroup.
//-----------------------------------------------
var disablingLoop = function(e, isVisible) {

  e.setVisible(isVisible);
  e.setDisabled(!isVisible);
};
//-----------------------------------------------
// Main form that contains all the fields
//-----------------------------------------------
Ext.namespace("Paraxip.wizard");

var isdn_form = new Ext.Panel({
  title           : "PSTN Digital Configuration",
  layout          : 'form',
  frame           : true,
  standardSubmit  : true,
  header          : false,
  id              : "Paraxip.wizard.isdn_form",
  defaults        : {
    autoHeight: true,
    autoWidth: true,
    layout: 'column'
  }  
});

var DigitDescriptionLabel = new Ext.form.Label({
  id    : "Paraxip.wizard.DigitDescriptionLabel",
  text  : "Select the PSTN digital configuration",  
  style : 'font-size:120%;font-weight:bold; line-height:60px;text-align:left;' 
});


//-----------------------------------------------
// Interface Type fields
//-----------------------------------------------
var radio_t1 = new Ext.form.Radio({
  boxLabel    : 'T1',
  id          : 'Radio_T1',
  name        : 'interface_type',
  inputValue  : 'T1',
  checked     : true
});

var radio_e1 = new Ext.form.Radio({
  boxLabel    : 'E1',
  id          : 'Radio_E1',
  name        : 'interface_type',
  inputValue  : 'E1',
  width       : 235,
  listeners   : {
    'check':function() {
      var parent = this.findParentByType('panel');

      var framing_T1 = parent.findById('framingT1');

      var framing_E1 = parent.findById('framingE1');

      var encoding_T1 = parent.findById('encodingT1');

      var encoding_E1 = parent.findById('encodingE1');

      var isdn_sw_T1 = parent.findById('isdnSwT1');

      var isdn_sw_E1 = parent.findById('isdnSwE1');

      var nfas_t1 = parent.findById('nfas');

      var isT1Visible;
      var isE1Visible;

      if (this.getValue()) {
        isT1Visible = false;
        isE1Visible = true;
      } else {
        isT1Visible = true;
        isE1Visible = false;
      }

      //T1 interface's fields
      disablingLoop(framing_T1, isT1Visible);
      disablingLoop(encoding_T1, isT1Visible);
      disablingLoop(isdn_sw_T1, isT1Visible);
      //disablingLoop(nfas_t1, isT1Visible);

      //E1 interface's fields
      disablingLoop(framing_E1, isE1Visible);
      disablingLoop(encoding_E1, isE1Visible);
      disablingLoop(isdn_sw_E1, isE1Visible);

    }
  }

});

var interfaces = new Ext.form.FieldSet({
  id          : "interfaces",
  title       : "Interface Type"
});

interfaces.add(radio_t1);
interfaces.add(radio_e1);

//-----------------------------------------------
// Framing Type fields
//-----------------------------------------------
var esf = new Ext.form.Radio({id:'esf_radio', boxLabel: 'ESF', name: 'framing_T1',inputValue: 'ESF', checked: 'true'});

var d4 = new Ext.form.Radio({id:'d4_radio', boxLabel: 'D4', name: 'framing_T1',inputValue: 'D4', width: 225});

//ESF_Japan not supported for now
//var esf_japan = new Ext.form.Radio({id:'esf_japan_radio', boxLabel: 'ESF Japan', name: 'framing_T1',inputValue: 'ESF_Japan', width: 150});

var crc4 = new Ext.form.Radio({id:'crc4_radio', boxLabel: 'CRC4', name: 'framing_E1',inputValue: 'CRC4', checked: 'true'});

var non_crc4 = new Ext.form.Radio({id:'non_crc4_radio', boxLabel: 'NON CRC4', name: 'framing_E1',inputValue: 'NonCRC4', width: 245});

var framing = new Ext.form.FieldSet({
  title       : "Framing Type",
  id          : "framingT1"
});

var framingE1 = new Ext.form.FieldSet({
  title       : "Framing Type",
  hidden      : true,
  id          : "framingE1"
});

framing.add(esf);
framingE1.add(crc4);
framing.add(d4);
framingE1.add(non_crc4);
//Uncomment when esf_japan will be supported
//framing.add(esf_japan);

//-----------------------------------------------
// Encoding Type fields
//-----------------------------------------------
var b8zs = new Ext.form.Radio({id:'b8zs_radio', boxLabel: 'B8ZS', name: 'encoding_T1',inputValue: 'B8ZS', checked: 'true'});

var ami_t1 = new Ext.form.Radio({id:'ami_t1_radio', boxLabel: 'AMI', name: 'encoding_T1',inputValue: 'AMI', width: 220});

var hdb3 = new Ext.form.Radio({id:'hdb3_radio', boxLabel: 'HDB3', name: 'encoding_E1',inputValue: 'HDB3', checked: 'true'});

var ami_e1 = new Ext.form.Radio({id:'ami_e1_radio', boxLabel: 'AMI', name: 'encoding_E1',inputValue: 'AMI', width: 217});

var encoding = new Ext.form.FieldSet({
  title       : "Encoding Type",
  id          : "encodingT1"
});

var encodingE1 = new Ext.form.FieldSet({
  title       : "Encoding Type",
  id          : "encodingE1",
  hidden      : true
});

encoding.add(b8zs);
encodingE1.add(hdb3);
encoding.add(ami_t1);
encodingE1.add(ami_e1);

//-----------------------------------------------
// ISDN Switch variant fields
//-----------------------------------------------
var ess = new Ext.form.Radio({id:'4ess_radio', boxLabel: '4ESS', name: 'isdn_sw_T1',inputValue: '4ESS'});

var lucent = new Ext.form.Radio({id:'lucent_radio', boxLabel: 'Lucent 5ESS', name: 'isdn_sw_T1',inputValue: '5ESS', checked: 'true', width: 260});

var etsi = new Ext.form.Radio({id:'etsi_radio', boxLabel: 'NET5 (ETSI, EuroISDN)', name: 'isdn_sw_E1',inputValue: 'ETSI', checked: 'true'});

var nortel = new Ext.form.Radio({id:'nortel_radio', boxLabel: 'Nortel DMS100', name: 'isdn_sw_T1', inputValue: 'DMS100'});

var ni2 = new Ext.form.Radio({id:'ni2_radio', boxLabel: 'National ISDN 2 (NI2)', name: 'isdn_sw_T1', inputValue: 'NI2', width: 300});

var isdn_sw = new Ext.form.FieldSet({
  title       : "ISDN Switch Variant",
  id          : "isdnSwT1"
});

var isdnSwE1 = new Ext.form.FieldSet({
  title       : "ISDN Switch Variant",
  id          : "isdnSwE1",
  hidden      : true
});

isdn_sw.add(ess);
isdn_sw.add(lucent);
isdnSwE1.add(etsi);
isdn_sw.add(nortel);
isdn_sw.add(ni2);

isdn_form.add(DigitDescriptionLabel);
isdn_form.add(interfaces);
isdn_form.add(framing);
isdn_form.add(framingE1);
isdn_form.add(encoding);
isdn_form.add(encodingE1);
isdn_form.add(isdn_sw);
isdn_form.add(isdnSwE1);


