#!/usr/bin/env python

#
# Generated Mon Jul 27 12:13:09 2009 by generateDS.py.
#

import sys
import getopt
from string import lower as str_lower
from xml.dom import minidom
from xml.dom import Node

#
# If you have installed IPython you can uncomment and use the following.
# IPython is available from http://ipython.scipy.org/.
#

## from IPython.Shell import IPShellEmbed
## args = ''
## ipshell = IPShellEmbed(args,
##     banner = 'Dropping into IPython',
##     exit_msg = 'Leaving Interpreter, back to program.')

# Then use the following line where and when you want to drop into the
# IPython shell:
#    ipshell('<some message> -- Entering ipshell.\nHit Ctrl-D to exit')

#
# Support/utility functions.
#

def showIndent(outfile, level):
    for idx in range(level):
        outfile.write('    ')

def quote_xml(inStr):
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    return s1

def quote_attrib(inStr):
    s1 = (isinstance(inStr, basestring) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('"', '&quot;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    return s1

def quote_python(inStr):
    s1 = inStr
    if s1.find("'") == -1:
        if s1.find('\n') == -1:
            return "'%s'" % s1
        else:
            return "'''%s'''" % s1
    else:
        if s1.find('"') != -1:
            s1 = s1.replace('"', '\\"')
        if s1.find('\n') == -1:
            return '"%s"' % s1
        else:
            return '"""%s"""' % s1


class MixedContainer:
    # Constants for category:
    CategoryNone = 0
    CategoryText = 1
    CategorySimple = 2
    CategoryComplex = 3
    # Constants for content_type:
    TypeNone = 0
    TypeText = 1
    TypeString = 2
    TypeInteger = 3
    TypeFloat = 4
    TypeDecimal = 5
    TypeDouble = 6
    TypeBoolean = 7
    def __init__(self, category, content_type, name, value):
        self.category = category
        self.content_type = content_type
        self.name = name
        self.value = value
    def getCategory(self):
        return self.category
    def getContenttype(self, content_type):
        return self.content_type
    def getValue(self):
        return self.value
    def getName(self):
        return self.name
    # PARAXIP export here doesn't have same signature than elsewhere
    def export(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            outfile.write(self.value)
        elif self.category == MixedContainer.CategorySimple:
            self.exportSimple(outfile, level, name)
        else:    # category == MixedContainer.CategoryComplex
            self.value.export(outfile, level, name)
    def exportSimple(self, outfile, level, name):
        if self.content_type == MixedContainer.TypeString:
            outfile.write('<%s>%s</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeInteger or \
                self.content_type == MixedContainer.TypeBoolean:
            outfile.write('<%s>%d</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeFloat or \
                self.content_type == MixedContainer.TypeDecimal:
            outfile.write('<%s>%f</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeDouble:
            outfile.write('<%s>%g</%s>' % (self.name, self.value, self.name))
    def exportLiteral(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            showIndent(outfile, level)
            outfile.write('MixedContainer(%d, %d, "%s", "%s"),\n' % \
                (self.category, self.content_type, self.name, self.value))
        elif self.category == MixedContainer.CategorySimple:
            showIndent(outfile, level)
            outfile.write('MixedContainer(%d, %d, "%s", "%s"),\n' % \
                (self.category, self.content_type, self.name, self.value))
        else:    # category == MixedContainer.CategoryComplex
            showIndent(outfile, level)
            outfile.write('MixedContainer(%d, %d, "%s",\n' % \
                (self.category, self.content_type, self.name,))
            self.value.exportLiteral(outfile, level + 1)
            showIndent(outfile, level)
            outfile.write(')\n')


class _MemberSpec(object):
    def __init__(self, name='', data_type='', container=0):
        self.name = name
        self.data_type = data_type
        self.container = container
    def set_name(self, name): self.name = name
    def get_name(self): return self.name
    def set_data_type(self, data_type): self.data_type = data_type
    def get_data_type(self): return self.data_type
    def set_container(self, container): self.container = container
    def get_container(self): return self.container


#
# Data representation classes.
#

class pstnConfig(object):
    subclass = None
    superclass = None
    def __init__(self, version='', providers=None, boards=None, physicalInterfaceConfigs=None, callControl=None):
        self.version = version
        self.providers = providers
        self.boards = boards
        self.physicalInterfaceConfigs = physicalInterfaceConfigs
        self.callControl = callControl
    def factory(*args_, **kwargs_):
        if pstnConfig.subclass:
            return pstnConfig.subclass(*args_, **kwargs_)
        else:
            return pstnConfig(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_providers(self): return self.providers
    def set_providers(self, providers): self.providers = providers
    def get_boards(self): return self.boards
    def set_boards(self, boards): self.boards = boards
    def get_physicalInterfaceConfigs(self): return self.physicalInterfaceConfigs
    def set_physicalInterfaceConfigs(self, physicalInterfaceConfigs): self.physicalInterfaceConfigs = physicalInterfaceConfigs
    def get_callControl(self): return self.callControl
    def set_callControl(self, callControl): self.callControl = callControl
    def get_version(self): return self.version
    def set_version(self, version): self.version = version
    def export(self, outfile, level, namespace_='', name_='pstnConfig'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='pstnConfig')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='pstnConfig'):
        outfile.write(' version="%s"' % (quote_attrib(self.get_version()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='pstnConfig'):
        if self.providers:
            self.providers.export(outfile, level, namespace_, name_='providers', )
        if self.boards:
            self.boards.export(outfile, level, namespace_, name_='boards', )
        if self.physicalInterfaceConfigs:
            self.physicalInterfaceConfigs.export(outfile, level, namespace_, name_='physicalInterfaceConfigs', )
        if self.callControl:
            self.callControl.export(outfile, level, namespace_, name_='callControl', )
    def exportLiteral(self, outfile, level, name_='pstnConfig'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('version = "%s",\n' % (self.get_version(),))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.providers:
            showIndent(outfile, level)
            outfile.write('providers=providers(\n')
            self.providers.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.boards:
            showIndent(outfile, level)
            outfile.write('boards=boards(\n')
            self.boards.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.physicalInterfaceConfigs:
            showIndent(outfile, level)
            outfile.write('physicalInterfaceConfigs=physicalInterfaceConfigs(\n')
            self.physicalInterfaceConfigs.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.callControl:
            showIndent(outfile, level)
            outfile.write('callControl=callControl(\n')
            self.callControl.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('version'):
            self.version = attrs.get('version').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'providers':
            obj_ = providers.factory()
            obj_.build(child_)
            self.set_providers(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'boards':
            obj_ = boards.factory()
            obj_.build(child_)
            self.set_boards(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'physicalInterfaceConfigs':
            obj_ = physicalInterfaceConfigs.factory()
            obj_.build(child_)
            self.set_physicalInterfaceConfigs(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'callControl':
            obj_ = callControl.factory()
            obj_.build(child_)
            self.set_callControl(obj_)
# end class pstnConfig


class providers(object):
    subclass = None
    superclass = None
    def __init__(self, sangoma=None):
        self.sangoma = sangoma
    def factory(*args_, **kwargs_):
        if providers.subclass:
            return providers.subclass(*args_, **kwargs_)
        else:
            return providers(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_sangoma(self): return self.sangoma
    def set_sangoma(self, sangoma): self.sangoma = sangoma
    def export(self, outfile, level, namespace_='', name_='providers'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='providers')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='providers'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='providers'):
        if self.get_sangoma() != None :
            if self.sangoma:
                self.sangoma.export(outfile, level, namespace_, name_='sangoma')
    def exportLiteral(self, outfile, level, name_='providers'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.sangoma:
            showIndent(outfile, level)
            outfile.write('sangoma=sangoma(\n')
            self.sangoma.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sangoma':
            obj_ = sangoma.factory()
            obj_.build(child_)
            self.set_sangoma(obj_)
# end class providers


class boards(object):
    subclass = None
    superclass = None
    def __init__(self, sangomaDigitalBoard=None, sangomaAnalogBoard=None, sangomaVirtualDigitalBoard=None):
        if sangomaDigitalBoard is None:
            self.sangomaDigitalBoard = []
        else:
            self.sangomaDigitalBoard = sangomaDigitalBoard
        if sangomaAnalogBoard is None:
            self.sangomaAnalogBoard = []
        else:
            self.sangomaAnalogBoard = sangomaAnalogBoard
        if sangomaVirtualDigitalBoard is None:
            self.sangomaVirtualDigitalBoard = []
        else:
            self.sangomaVirtualDigitalBoard = sangomaVirtualDigitalBoard
    def factory(*args_, **kwargs_):
        if boards.subclass:
            return boards.subclass(*args_, **kwargs_)
        else:
            return boards(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_sangomaDigitalBoard(self): return self.sangomaDigitalBoard
    def set_sangomaDigitalBoard(self, sangomaDigitalBoard): self.sangomaDigitalBoard = sangomaDigitalBoard
    def add_sangomaDigitalBoard(self, value): self.sangomaDigitalBoard.append(value)
    def insert_sangomaDigitalBoard(self, index, value): self.sangomaDigitalBoard[index] = value
    def get_sangomaAnalogBoard(self): return self.sangomaAnalogBoard
    def set_sangomaAnalogBoard(self, sangomaAnalogBoard): self.sangomaAnalogBoard = sangomaAnalogBoard
    def add_sangomaAnalogBoard(self, value): self.sangomaAnalogBoard.append(value)
    def insert_sangomaAnalogBoard(self, index, value): self.sangomaAnalogBoard[index] = value
    def get_sangomaVirtualDigitalBoard(self): return self.sangomaVirtualDigitalBoard
    def set_sangomaVirtualDigitalBoard(self, sangomaVirtualDigitalBoard): self.sangomaVirtualDigitalBoard = sangomaVirtualDigitalBoard
    def add_sangomaVirtualDigitalBoard(self, value): self.sangomaVirtualDigitalBoard.append(value)
    def insert_sangomaVirtualDigitalBoard(self, index, value): self.sangomaVirtualDigitalBoard[index] = value
    def export(self, outfile, level, namespace_='', name_='boards'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='boards')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='boards'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='boards'):
        for sangomaDigitalBoard_ in self.get_sangomaDigitalBoard():
            sangomaDigitalBoard_.export(outfile, level, namespace_, name_='sangomaDigitalBoard')
        for sangomaAnalogBoard_ in self.get_sangomaAnalogBoard():
            sangomaAnalogBoard_.export(outfile, level, namespace_, name_='sangomaAnalogBoard')
        for sangomaVirtualDigitalBoard_ in self.get_sangomaVirtualDigitalBoard():
            sangomaVirtualDigitalBoard_.export(outfile, level, namespace_, name_='sangomaVirtualDigitalBoard')
    def exportLiteral(self, outfile, level, name_='boards'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('sangomaDigitalBoard=[\n')
        level += 1
        for sangomaDigitalBoard in self.sangomaDigitalBoard:
            showIndent(outfile, level)
            outfile.write('sangomaDigitalBoard(\n')
            sangomaDigitalBoard.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('sangomaAnalogBoard=[\n')
        level += 1
        for sangomaAnalogBoard in self.sangomaAnalogBoard:
            showIndent(outfile, level)
            outfile.write('sangomaAnalogBoard(\n')
            sangomaAnalogBoard.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('sangomaVirtualDigitalBoard=[\n')
        level += 1
        for sangomaVirtualDigitalBoard in self.sangomaVirtualDigitalBoard:
            showIndent(outfile, level)
            outfile.write('sangomaVirtualDigitalBoard(\n')
            sangomaVirtualDigitalBoard.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sangomaDigitalBoard':
            obj_ = sangomaDigitalBoard.factory()
            obj_.build(child_)
            self.sangomaDigitalBoard.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sangomaAnalogBoard':
            obj_ = sangomaAnalogBoard.factory()
            obj_.build(child_)
            self.sangomaAnalogBoard.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sangomaVirtualDigitalBoard':
            obj_ = sangomaVirtualDigitalBoard.factory()
            obj_.build(child_)
            self.sangomaVirtualDigitalBoard.append(obj_)
# end class boards


class physicalInterfaceConfigs(object):
    subclass = None
    superclass = None
    def __init__(self, sangomaDigitalConfig=None, sangomaAnalogConfig=None):
        if sangomaDigitalConfig is None:
            self.sangomaDigitalConfig = []
        else:
            self.sangomaDigitalConfig = sangomaDigitalConfig
        if sangomaAnalogConfig is None:
            self.sangomaAnalogConfig = []
        else:
            self.sangomaAnalogConfig = sangomaAnalogConfig
    def factory(*args_, **kwargs_):
        if physicalInterfaceConfigs.subclass:
            return physicalInterfaceConfigs.subclass(*args_, **kwargs_)
        else:
            return physicalInterfaceConfigs(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_sangomaDigitalConfig(self): return self.sangomaDigitalConfig
    def set_sangomaDigitalConfig(self, sangomaDigitalConfig): self.sangomaDigitalConfig = sangomaDigitalConfig
    def add_sangomaDigitalConfig(self, value): self.sangomaDigitalConfig.append(value)
    def insert_sangomaDigitalConfig(self, index, value): self.sangomaDigitalConfig[index] = value
    def get_sangomaAnalogConfig(self): return self.sangomaAnalogConfig
    def set_sangomaAnalogConfig(self, sangomaAnalogConfig): self.sangomaAnalogConfig = sangomaAnalogConfig
    def add_sangomaAnalogConfig(self, value): self.sangomaAnalogConfig.append(value)
    def insert_sangomaAnalogConfig(self, index, value): self.sangomaAnalogConfig[index] = value
    def export(self, outfile, level, namespace_='', name_='physicalInterfaceConfigs'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='physicalInterfaceConfigs')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='physicalInterfaceConfigs'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='physicalInterfaceConfigs'):
        for sangomaDigitalConfig_ in self.get_sangomaDigitalConfig():
            sangomaDigitalConfig_.export(outfile, level, namespace_, name_='sangomaDigitalConfig')
        for sangomaAnalogConfig_ in self.get_sangomaAnalogConfig():
            sangomaAnalogConfig_.export(outfile, level, namespace_, name_='sangomaAnalogConfig')
    def exportLiteral(self, outfile, level, name_='physicalInterfaceConfigs'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('sangomaDigitalConfig=[\n')
        level += 1
        for sangomaDigitalConfig in self.sangomaDigitalConfig:
            showIndent(outfile, level)
            outfile.write('sangomaDigitalConfig(\n')
            sangomaDigitalConfig.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('sangomaAnalogConfig=[\n')
        level += 1
        for sangomaAnalogConfig in self.sangomaAnalogConfig:
            showIndent(outfile, level)
            outfile.write('sangomaAnalogConfig(\n')
            sangomaAnalogConfig.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sangomaDigitalConfig':
            obj_ = sangomaDigitalConfig.factory()
            obj_.build(child_)
            self.sangomaDigitalConfig.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'sangomaAnalogConfig':
            obj_ = sangomaAnalogConfig.factory()
            obj_.build(child_)
            self.sangomaAnalogConfig.append(obj_)
# end class physicalInterfaceConfigs


class callControl(object):
    subclass = None
    superclass = None
    def __init__(self, channelGroups=None, isdn=None, analog=None):
        self.channelGroups = channelGroups
        self.isdn = isdn
        self.analog = analog
    def factory(*args_, **kwargs_):
        if callControl.subclass:
            return callControl.subclass(*args_, **kwargs_)
        else:
            return callControl(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_channelGroups(self): return self.channelGroups
    def set_channelGroups(self, channelGroups): self.channelGroups = channelGroups
    def get_isdn(self): return self.isdn
    def set_isdn(self, isdn): self.isdn = isdn
    def get_analog(self): return self.analog
    def set_analog(self, analog): self.analog = analog
    def export(self, outfile, level, namespace_='', name_='callControl'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='callControl')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='callControl'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='callControl'):
        if self.channelGroups:
            self.channelGroups.export(outfile, level, namespace_, name_='channelGroups', )
        if self.get_isdn() != None :
            if self.isdn:
                self.isdn.export(outfile, level, namespace_, name_='isdn')
        if self.get_analog() != None :
            if self.analog:
                self.analog.export(outfile, level, namespace_, name_='analog')
    def exportLiteral(self, outfile, level, name_='callControl'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.channelGroups:
            showIndent(outfile, level)
            outfile.write('channelGroups=channelGroups(\n')
            self.channelGroups.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.isdn:
            showIndent(outfile, level)
            outfile.write('isdn=isdn(\n')
            self.isdn.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.analog:
            showIndent(outfile, level)
            outfile.write('analog=analog(\n')
            self.analog.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'channelGroups':
            obj_ = channelGroups.factory()
            obj_.build(child_)
            self.set_channelGroups(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'isdn':
            obj_ = isdn.factory()
            obj_.build(child_)
            self.set_isdn(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'analog':
            obj_ = analog.factory()
            obj_.build(child_)
            self.set_analog(obj_)
# end class callControl


class channelGroups(object):
    subclass = None
    superclass = None
    def __init__(self, channelGroup=None):
        if channelGroup is None:
            self.channelGroup = []
        else:
            self.channelGroup = channelGroup
    def factory(*args_, **kwargs_):
        if channelGroups.subclass:
            return channelGroups.subclass(*args_, **kwargs_)
        else:
            return channelGroups(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_channelGroup(self): return self.channelGroup
    def set_channelGroup(self, channelGroup): self.channelGroup = channelGroup
    def add_channelGroup(self, value): self.channelGroup.append(value)
    def insert_channelGroup(self, index, value): self.channelGroup[index] = value
    def validate_channelGroup(self, value):
        # validate type channelGroup
        pass
    def export(self, outfile, level, namespace_='', name_='channelGroups'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='channelGroups')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='channelGroups'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='channelGroups'):
        for channelGroup_ in self.get_channelGroup():
            channelGroup_.export(outfile, level, namespace_, name_='channelGroup')
    def exportLiteral(self, outfile, level, name_='channelGroups'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('channelGroup=[\n')
        level += 1
        for channelGroup in self.channelGroup:
            showIndent(outfile, level)
            outfile.write('channelGroup(\n')
            channelGroup.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'channelGroup':
            obj_ = channelGroup.factory()
            obj_.build(child_)
            self.channelGroup.append(obj_)
            self.validate_channelGroup(self.channelGroup)    # validate type channelGroup
# end class channelGroups


class channelGroup(object):
    subclass = None
    superclass = None
    def __init__(self, outboundHuntingScheme=None, direction='', ID='', valueOf_=''):
        self.outboundHuntingScheme = outboundHuntingScheme
        self.direction = direction
        self.ID = ID
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if channelGroup.subclass:
            return channelGroup.subclass(*args_, **kwargs_)
        else:
            return channelGroup(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_outboundHuntingScheme(self): return self.outboundHuntingScheme
    def set_outboundHuntingScheme(self, outboundHuntingScheme): self.outboundHuntingScheme = outboundHuntingScheme
    def get_direction(self): return self.direction
    def set_direction(self, direction): self.direction = direction
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='channelGroup'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='channelGroup')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='channelGroup'):
        if self.get_outboundHuntingScheme() is not None:
            outfile.write(' outboundHuntingScheme="%s"' % (quote_attrib(self.get_outboundHuntingScheme()), ))
        outfile.write(' direction="%s"' % (quote_attrib(self.get_direction()), ))
        outfile.write(' ID="%s"' % (quote_attrib(self.get_ID()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='channelGroup'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='channelGroup'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('outboundHuntingScheme = "%s",\n' % (self.get_outboundHuntingScheme(),))
        showIndent(outfile, level)
        outfile.write('direction = "%s",\n' % (self.get_direction(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('outboundHuntingScheme'):
            self.outboundHuntingScheme = attrs.get('outboundHuntingScheme').value
        if attrs.get('direction'):
            self.direction = attrs.get('direction').value
        if attrs.get('ID'):
            self.ID = attrs.get('ID').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class channelGroup


class isdn(object):
    subclass = None
    superclass = None
    def __init__(self, fasConfig=None, nfasGroup=None):
        if fasConfig is None:
            self.fasConfig = []
        else:
            self.fasConfig = fasConfig
        if nfasGroup is None:
            self.nfasGroup = []
        else:
            self.nfasGroup = nfasGroup
    def factory(*args_, **kwargs_):
        if isdn.subclass:
            return isdn.subclass(*args_, **kwargs_)
        else:
            return isdn(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_fasConfig(self): return self.fasConfig
    def set_fasConfig(self, fasConfig): self.fasConfig = fasConfig
    def add_fasConfig(self, value): self.fasConfig.append(value)
    def insert_fasConfig(self, index, value): self.fasConfig[index] = value
    def get_nfasGroup(self): return self.nfasGroup
    def set_nfasGroup(self, nfasGroup): self.nfasGroup = nfasGroup
    def add_nfasGroup(self, value): self.nfasGroup.append(value)
    def insert_nfasGroup(self, index, value): self.nfasGroup[index] = value
    def export(self, outfile, level, namespace_='', name_='isdn'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='isdn')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='isdn'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='isdn'):
        for fasConfig_ in self.get_fasConfig():
            fasConfig_.export(outfile, level, namespace_, name_='fasConfig')
        for nfasGroup_ in self.get_nfasGroup():
            nfasGroup_.export(outfile, level, namespace_, name_='nfasGroup')
    def exportLiteral(self, outfile, level, name_='isdn'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('fasConfig=[\n')
        level += 1
        for fasConfig in self.fasConfig:
            showIndent(outfile, level)
            outfile.write('fasConfig(\n')
            fasConfig.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('nfasGroup=[\n')
        level += 1
        for nfasGroup in self.nfasGroup:
            showIndent(outfile, level)
            outfile.write('nfasGroup(\n')
            nfasGroup.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'fasConfig':
            obj_ = fasConfig.factory()
            obj_.build(child_)
            self.fasConfig.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'nfasGroup':
            obj_ = nfasGroup.factory()
            obj_.build(child_)
            self.nfasGroup.append(obj_)
# end class isdn


class sangoma(object):
    subclass = None
    superclass = None
    def __init__(self, BChannelsThreads=None, DChannelsThreads=None, TxMediaStreams=None, RxMediaStreams=None):
        self.BChannelsThreads = BChannelsThreads
        self.DChannelsThreads = DChannelsThreads
        self.TxMediaStreams = TxMediaStreams
        self.RxMediaStreams = RxMediaStreams
    def factory(*args_, **kwargs_):
        if sangoma.subclass:
            return sangoma.subclass(*args_, **kwargs_)
        else:
            return sangoma(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_BChannelsThreads(self): return self.BChannelsThreads
    def set_BChannelsThreads(self, BChannelsThreads): self.BChannelsThreads = BChannelsThreads
    def get_DChannelsThreads(self): return self.DChannelsThreads
    def set_DChannelsThreads(self, DChannelsThreads): self.DChannelsThreads = DChannelsThreads
    def get_TxMediaStreams(self): return self.TxMediaStreams
    def set_TxMediaStreams(self, TxMediaStreams): self.TxMediaStreams = TxMediaStreams
    def get_RxMediaStreams(self): return self.RxMediaStreams
    def set_RxMediaStreams(self, RxMediaStreams): self.RxMediaStreams = RxMediaStreams
    def export(self, outfile, level, namespace_='', name_='sangoma'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='sangoma')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='sangoma'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='sangoma'):
        if self.BChannelsThreads:
            self.BChannelsThreads.export(outfile, level, namespace_, name_='BChannelsThreads', )
        if self.DChannelsThreads:
            self.DChannelsThreads.export(outfile, level, namespace_, name_='DChannelsThreads', )
        if self.get_TxMediaStreams() != None :
            if self.TxMediaStreams:
                self.TxMediaStreams.export(outfile, level, namespace_, name_='TxMediaStreams')
        if self.get_RxMediaStreams() != None :
            if self.RxMediaStreams:
                self.RxMediaStreams.export(outfile, level, namespace_, name_='RxMediaStreams')
    def exportLiteral(self, outfile, level, name_='sangoma'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.BChannelsThreads:
            showIndent(outfile, level)
            outfile.write('BChannelsThreads=BChannelsThreads(\n')
            self.BChannelsThreads.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.DChannelsThreads:
            showIndent(outfile, level)
            outfile.write('DChannelsThreads=DChannelsThreads(\n')
            self.DChannelsThreads.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.TxMediaStreams:
            showIndent(outfile, level)
            outfile.write('TxMediaStreams=TxMediaStreams(\n')
            self.TxMediaStreams.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.RxMediaStreams:
            showIndent(outfile, level)
            outfile.write('RxMediaStreams=RxMediaStreams(\n')
            self.RxMediaStreams.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BChannelsThreads':
            obj_ = BChannelsThreads.factory()
            obj_.build(child_)
            self.set_BChannelsThreads(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DChannelsThreads':
            obj_ = DChannelsThreads.factory()
            obj_.build(child_)
            self.set_DChannelsThreads(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'TxMediaStreams':
            obj_ = TxMediaStreams.factory()
            obj_.build(child_)
            self.set_TxMediaStreams(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RxMediaStreams':
            obj_ = RxMediaStreams.factory()
            obj_.build(child_)
            self.set_RxMediaStreams(obj_)
# end class sangoma


class BChannelsThreads(object):
    subclass = None
    superclass = None
    def __init__(self, count=1, priority=None, valueOf_=''):
        self.count = count
        self.priority = priority
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if BChannelsThreads.subclass:
            return BChannelsThreads.subclass(*args_, **kwargs_)
        else:
            return BChannelsThreads(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_count(self): return self.count
    def set_count(self, count): self.count = count
    def get_priority(self): return self.priority
    def set_priority(self, priority): self.priority = priority
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='BChannelsThreads'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='BChannelsThreads')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='BChannelsThreads'):
        outfile.write(' count="%d"' % self.get_count())
        outfile.write(' priority="%s"' % str(self.get_priority()))
    def exportChildren(self, outfile, level, namespace_='', name_='BChannelsThreads'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='BChannelsThreads'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('count = "%s",\n' % (self.get_count(),))
        showIndent(outfile, level)
        outfile.write('priority = "%s",\n' % (self.get_priority(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('count'):
            try:
                self.count = int(attrs.get('count').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (count): %s' % exp)
            if self.count <= 0:
                raise ValueError('Invalid PositiveInteger (count)')
        if attrs.get('priority'):
            self.priority = attrs.get('priority').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class BChannelsThreads


class DChannelsThreads(object):
    subclass = None
    superclass = None
    def __init__(self, count=1, priority=None, valueOf_=''):
        self.count = count
        self.priority = priority
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DChannelsThreads.subclass:
            return DChannelsThreads.subclass(*args_, **kwargs_)
        else:
            return DChannelsThreads(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_count(self): return self.count
    def set_count(self, count): self.count = count
    def get_priority(self): return self.priority
    def set_priority(self, priority): self.priority = priority
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='DChannelsThreads'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='DChannelsThreads')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='DChannelsThreads'):
        outfile.write(' count="%d"' % self.get_count())
        outfile.write(' priority="%s"' % str(self.get_priority()))
    def exportChildren(self, outfile, level, namespace_='', name_='DChannelsThreads'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='DChannelsThreads'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('count = "%s",\n' % (self.get_count(),))
        showIndent(outfile, level)
        outfile.write('priority = "%s",\n' % (self.get_priority(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('count'):
            try:
                self.count = int(attrs.get('count').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (count): %s' % exp)
            if self.count <= 0:
                raise ValueError('Invalid PositiveInteger (count)')
        if attrs.get('priority'):
            self.priority = attrs.get('priority').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class DChannelsThreads


class TxMediaStreams(object):
    subclass = None
    superclass = None
    def __init__(self, reverseBits=None, valueOf_=''):
        self.reverseBits = reverseBits
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if TxMediaStreams.subclass:
            return TxMediaStreams.subclass(*args_, **kwargs_)
        else:
            return TxMediaStreams(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_reverseBits(self): return self.reverseBits
    def set_reverseBits(self, reverseBits): self.reverseBits = reverseBits
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='TxMediaStreams'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='TxMediaStreams')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='TxMediaStreams'):
        if self.get_reverseBits() is not None:
            outfile.write(' reverseBits="%s"' % str(self.get_reverseBits()))
    def exportChildren(self, outfile, level, namespace_='', name_='TxMediaStreams'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='TxMediaStreams'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('reverseBits = "%s",\n' % (self.get_reverseBits(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('reverseBits'):
            self.reverseBits = attrs.get('reverseBits').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class TxMediaStreams


class RxMediaStreams(object):
    subclass = None
    superclass = None
    def __init__(self, reverseBits=None, valueOf_=''):
        self.reverseBits = reverseBits
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if RxMediaStreams.subclass:
            return RxMediaStreams.subclass(*args_, **kwargs_)
        else:
            return RxMediaStreams(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_reverseBits(self): return self.reverseBits
    def set_reverseBits(self, reverseBits): self.reverseBits = reverseBits
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='RxMediaStreams'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='RxMediaStreams')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='RxMediaStreams'):
        if self.get_reverseBits() is not None:
            outfile.write(' reverseBits="%s"' % str(self.get_reverseBits()))
    def exportChildren(self, outfile, level, namespace_='', name_='RxMediaStreams'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='RxMediaStreams'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('reverseBits = "%s",\n' % (self.get_reverseBits(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('reverseBits'):
            self.reverseBits = attrs.get('reverseBits').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class RxMediaStreams


class sangomaDigitalConfig(object):
    subclass = None
    superclass = None
    def __init__(self, displayName='', ID=1, digitalT1=None, digitalE1=None, audio=None, applyTo=None):
        self.displayName = displayName
        self.ID = ID
        self.digitalT1 = digitalT1
        self.digitalE1 = digitalE1
        self.audio = audio
        self.applyTo = applyTo
    def factory(*args_, **kwargs_):
        if sangomaDigitalConfig.subclass:
            return sangomaDigitalConfig.subclass(*args_, **kwargs_)
        else:
            return sangomaDigitalConfig(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_digitalT1(self): return self.digitalT1
    def set_digitalT1(self, digitalT1): self.digitalT1 = digitalT1
    def validate_digitalT1(self, value):
        # validate type digitalT1
        pass
    def get_digitalE1(self): return self.digitalE1
    def set_digitalE1(self, digitalE1): self.digitalE1 = digitalE1
    def validate_digitalE1(self, value):
        # validate type digitalE1
        pass
    def get_audio(self): return self.audio
    def set_audio(self, audio): self.audio = audio
    def validate_audio(self, value):
        # validate type audio
        pass
    def get_applyTo(self): return self.applyTo
    def set_applyTo(self, applyTo): self.applyTo = applyTo
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def export(self, outfile, level, namespace_='', name_='sangomaDigitalConfig'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='sangomaDigitalConfig')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='sangomaDigitalConfig'):
        outfile.write(' displayName="%s"' % (quote_attrib(self.get_displayName()), ))
        outfile.write(' ID="%d"' % self.get_ID())
    def exportChildren(self, outfile, level, namespace_='', name_='sangomaDigitalConfig'):
        if self.digitalT1:
            self.digitalT1.export(outfile, level, namespace_, name_='digitalT1', )
        if self.digitalE1:
            self.digitalE1.export(outfile, level, namespace_, name_='digitalE1', )
        if self.audio:
            self.audio.export(outfile, level, namespace_, name_='audio', )
        if self.applyTo:
            self.applyTo.export(outfile, level, namespace_, name_='applyTo', )
    def exportLiteral(self, outfile, level, name_='sangomaDigitalConfig'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('displayName = "%s",\n' % (self.get_displayName(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.digitalT1:
            showIndent(outfile, level)
            outfile.write('digitalT1=digitalT1(\n')
            self.digitalT1.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.digitalE1:
            showIndent(outfile, level)
            outfile.write('digitalE1=digitalE1(\n')
            self.digitalE1.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.audio:
            showIndent(outfile, level)
            outfile.write('audio=audio(\n')
            self.audio.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.applyTo:
            showIndent(outfile, level)
            outfile.write('applyTo=applyTo(\n')
            self.applyTo.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('displayName'):
            self.displayName = attrs.get('displayName').value
        if attrs.get('ID'):
            try:
                self.ID = int(attrs.get('ID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ID): %s' % exp)
            if self.ID <= 0:
                raise ValueError('Invalid PositiveInteger (ID)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'digitalT1':
            obj_ = digitalT1.factory()
            obj_.build(child_)
            self.set_digitalT1(obj_)
            self.validate_digitalT1(self.digitalT1)    # validate type digitalT1
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'digitalE1':
            obj_ = digitalE1.factory()
            obj_.build(child_)
            self.set_digitalE1(obj_)
            self.validate_digitalE1(self.digitalE1)    # validate type digitalE1
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'audio':
            obj_ = audio.factory()
            obj_.build(child_)
            self.set_audio(obj_)
            self.validate_audio(self.audio)    # validate type audio
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'applyTo':
            obj_ = applyTo.factory()
            obj_.build(child_)
            self.set_applyTo(obj_)
# end class sangomaDigitalConfig


class sangomaAnalogConfig(object):
    subclass = None
    superclass = None
    def __init__(self, displayName='', ID=1, analog=None, audio=None, applyTo=None):
        self.displayName = displayName
        self.ID = ID
        self.analog = analog
        self.audio = audio
        self.applyTo = applyTo
    def factory(*args_, **kwargs_):
        if sangomaAnalogConfig.subclass:
            return sangomaAnalogConfig.subclass(*args_, **kwargs_)
        else:
            return sangomaAnalogConfig(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_analog(self): return self.analog
    def set_analog(self, analog): self.analog = analog
    def get_audio(self): return self.audio
    def set_audio(self, audio): self.audio = audio
    def validate_audio(self, value):
        # validate type audio
        pass
    def get_applyTo(self): return self.applyTo
    def set_applyTo(self, applyTo): self.applyTo = applyTo
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def export(self, outfile, level, namespace_='', name_='sangomaAnalogConfig'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='sangomaAnalogConfig')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='sangomaAnalogConfig'):
        outfile.write(' displayName="%s"' % (quote_attrib(self.get_displayName()), ))
        outfile.write(' ID="%d"' % self.get_ID())
    def exportChildren(self, outfile, level, namespace_='', name_='sangomaAnalogConfig'):
        if self.analog:
            self.analog.export(outfile, level, namespace_, name_='analog', )
        if self.audio:
            self.audio.export(outfile, level, namespace_, name_='audio', )
        if self.applyTo:
            self.applyTo.export(outfile, level, namespace_, name_='applyTo', )
    def exportLiteral(self, outfile, level, name_='sangomaAnalogConfig'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('displayName = "%s",\n' % (self.get_displayName(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.analog:
            showIndent(outfile, level)
            outfile.write('analog=analog(\n')
            self.analog.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.audio:
            showIndent(outfile, level)
            outfile.write('audio=audio(\n')
            self.audio.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.applyTo:
            showIndent(outfile, level)
            outfile.write('applyTo=applyTo(\n')
            self.applyTo.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('displayName'):
            self.displayName = attrs.get('displayName').value
        if attrs.get('ID'):
            try:
                self.ID = int(attrs.get('ID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ID): %s' % exp)
            if self.ID <= 0:
                raise ValueError('Invalid PositiveInteger (ID)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'analog':
            obj_ = analog.factory()
            obj_.build(child_)
            self.set_analog(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'audio':
            obj_ = audio.factory()
            obj_.build(child_)
            self.set_audio(obj_)
            self.validate_audio(self.audio)    # validate type audio
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'applyTo':
            obj_ = applyTo.factory()
            obj_.build(child_)
            self.set_applyTo(obj_)
# end class sangomaAnalogConfig


class digitalT1(object):
    subclass = None
    superclass = None
    def __init__(self, loopbackMode=None, clocking='', framing='', LBO='', lineEncoding='', DChannelT1=None):
        self.loopbackMode = loopbackMode
        self.clocking = clocking
        self.framing = framing
        self.LBO = LBO
        self.lineEncoding = lineEncoding
        self.DChannelT1 = DChannelT1
    def factory(*args_, **kwargs_):
        if digitalT1.subclass:
            return digitalT1.subclass(*args_, **kwargs_)
        else:
            return digitalT1(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_DChannelT1(self): return self.DChannelT1
    def set_DChannelT1(self, DChannelT1): self.DChannelT1 = DChannelT1
    def validate_DChannelT1(self, value):
        # validate type DChannelT1
        pass
    def get_loopbackMode(self): return self.loopbackMode
    def set_loopbackMode(self, loopbackMode): self.loopbackMode = loopbackMode
    def get_clocking(self): return self.clocking
    def set_clocking(self, clocking): self.clocking = clocking
    def get_framing(self): return self.framing
    def set_framing(self, framing): self.framing = framing
    def get_LBO(self): return self.LBO
    def set_LBO(self, LBO): self.LBO = LBO
    def get_lineEncoding(self): return self.lineEncoding
    def set_lineEncoding(self, lineEncoding): self.lineEncoding = lineEncoding
    def export(self, outfile, level, namespace_='', name_='digitalT1'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='digitalT1')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='digitalT1'):
        if self.get_loopbackMode() is not None:
            outfile.write(' loopbackMode="%s"' % (quote_attrib(self.get_loopbackMode()), ))
        outfile.write(' clocking="%s"' % (quote_attrib(self.get_clocking()), ))
        outfile.write(' framing="%s"' % (quote_attrib(self.get_framing()), ))
        outfile.write(' LBO="%s"' % (quote_attrib(self.get_LBO()), ))
        outfile.write(' lineEncoding="%s"' % (quote_attrib(self.get_lineEncoding()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='digitalT1'):
        if self.get_DChannelT1() != None :
            if self.DChannelT1:
                self.DChannelT1.export(outfile, level, namespace_, name_='DChannelT1')
    def exportLiteral(self, outfile, level, name_='digitalT1'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('loopbackMode = "%s",\n' % (self.get_loopbackMode(),))
        showIndent(outfile, level)
        outfile.write('clocking = "%s",\n' % (self.get_clocking(),))
        showIndent(outfile, level)
        outfile.write('framing = "%s",\n' % (self.get_framing(),))
        showIndent(outfile, level)
        outfile.write('LBO = "%s",\n' % (self.get_LBO(),))
        showIndent(outfile, level)
        outfile.write('lineEncoding = "%s",\n' % (self.get_lineEncoding(),))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.DChannelT1:
            showIndent(outfile, level)
            outfile.write('DChannelT1=DChannelT1(\n')
            self.DChannelT1.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('loopbackMode'):
            self.loopbackMode = attrs.get('loopbackMode').value
        if attrs.get('clocking'):
            self.clocking = attrs.get('clocking').value
        if attrs.get('framing'):
            self.framing = attrs.get('framing').value
        if attrs.get('LBO'):
            self.LBO = attrs.get('LBO').value
        if attrs.get('lineEncoding'):
            self.lineEncoding = attrs.get('lineEncoding').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DChannelT1':
            obj_ = DChannelT1.factory()
            obj_.build(child_)
            self.set_DChannelT1(obj_)
            self.validate_DChannelT1(self.DChannelT1)    # validate type DChannelT1
# end class digitalT1


class DChannelT1(object):
    subclass = None
    superclass = None
    def __init__(self, mtuSize='', channelIndex='', valueOf_=''):
        self.mtuSize = mtuSize
        self.channelIndex = channelIndex
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DChannelT1.subclass:
            return DChannelT1.subclass(*args_, **kwargs_)
        else:
            return DChannelT1(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_mtuSize(self): return self.mtuSize
    def set_mtuSize(self, mtuSize): self.mtuSize = mtuSize
    def get_channelIndex(self): return self.channelIndex
    def set_channelIndex(self, channelIndex): self.channelIndex = channelIndex
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='DChannelT1'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='DChannelT1')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='DChannelT1'):
        outfile.write(' mtuSize="%s"' % (quote_attrib(self.get_mtuSize()), ))
        outfile.write(' channelIndex="%s"' % (quote_attrib(self.get_channelIndex()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='DChannelT1'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='DChannelT1'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('mtuSize = "%s",\n' % (self.get_mtuSize(),))
        showIndent(outfile, level)
        outfile.write('channelIndex = "%s",\n' % (self.get_channelIndex(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('mtuSize'):
            self.mtuSize = attrs.get('mtuSize').value
        if attrs.get('channelIndex'):
            self.channelIndex = attrs.get('channelIndex').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class DChannelT1


class digitalE1(object):
    subclass = None
    superclass = None
    def __init__(self, E1Termination='', lineEncoding='', clocking='', loopbackMode=None, framing='', E1Signaling='', DChannelE1=None):
        self.E1Termination = E1Termination
        self.lineEncoding = lineEncoding
        self.clocking = clocking
        self.loopbackMode = loopbackMode
        self.framing = framing
        self.E1Signaling = E1Signaling
        self.DChannelE1 = DChannelE1
    def factory(*args_, **kwargs_):
        if digitalE1.subclass:
            return digitalE1.subclass(*args_, **kwargs_)
        else:
            return digitalE1(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_DChannelE1(self): return self.DChannelE1
    def set_DChannelE1(self, DChannelE1): self.DChannelE1 = DChannelE1
    def validate_DChannelE1(self, value):
        # validate type DChannelE1
        pass
    def get_E1Termination(self): return self.E1Termination
    def set_E1Termination(self, E1Termination): self.E1Termination = E1Termination
    def get_lineEncoding(self): return self.lineEncoding
    def set_lineEncoding(self, lineEncoding): self.lineEncoding = lineEncoding
    def get_clocking(self): return self.clocking
    def set_clocking(self, clocking): self.clocking = clocking
    def get_loopbackMode(self): return self.loopbackMode
    def set_loopbackMode(self, loopbackMode): self.loopbackMode = loopbackMode
    def get_framing(self): return self.framing
    def set_framing(self, framing): self.framing = framing
    def get_E1Signaling(self): return self.E1Signaling
    def set_E1Signaling(self, E1Signaling): self.E1Signaling = E1Signaling
    def export(self, outfile, level, namespace_='', name_='digitalE1'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='digitalE1')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='digitalE1'):
        outfile.write(' E1Termination="%s"' % (quote_attrib(self.get_E1Termination()), ))
        outfile.write(' lineEncoding="%s"' % (quote_attrib(self.get_lineEncoding()), ))
        outfile.write(' clocking="%s"' % (quote_attrib(self.get_clocking()), ))
        if self.get_loopbackMode() is not None:
            outfile.write(' loopbackMode="%s"' % (quote_attrib(self.get_loopbackMode()), ))
        outfile.write(' framing="%s"' % (quote_attrib(self.get_framing()), ))
        outfile.write(' E1Signaling="%s"' % (quote_attrib(self.get_E1Signaling()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='digitalE1'):
        if self.get_DChannelE1() != None :
            if self.DChannelE1:
                self.DChannelE1.export(outfile, level, namespace_, name_='DChannelE1')
    def exportLiteral(self, outfile, level, name_='digitalE1'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('E1Termination = "%s",\n' % (self.get_E1Termination(),))
        showIndent(outfile, level)
        outfile.write('lineEncoding = "%s",\n' % (self.get_lineEncoding(),))
        showIndent(outfile, level)
        outfile.write('clocking = "%s",\n' % (self.get_clocking(),))
        showIndent(outfile, level)
        outfile.write('loopbackMode = "%s",\n' % (self.get_loopbackMode(),))
        showIndent(outfile, level)
        outfile.write('framing = "%s",\n' % (self.get_framing(),))
        showIndent(outfile, level)
        outfile.write('E1Signaling = "%s",\n' % (self.get_E1Signaling(),))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.DChannelE1:
            showIndent(outfile, level)
            outfile.write('DChannelE1=DChannelE1(\n')
            self.DChannelE1.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('E1Termination'):
            self.E1Termination = attrs.get('E1Termination').value
        if attrs.get('lineEncoding'):
            self.lineEncoding = attrs.get('lineEncoding').value
        if attrs.get('clocking'):
            self.clocking = attrs.get('clocking').value
        if attrs.get('loopbackMode'):
            self.loopbackMode = attrs.get('loopbackMode').value
        if attrs.get('framing'):
            self.framing = attrs.get('framing').value
        if attrs.get('E1Signaling'):
            self.E1Signaling = attrs.get('E1Signaling').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DChannelE1':
            obj_ = DChannelE1.factory()
            obj_.build(child_)
            self.set_DChannelE1(obj_)
            self.validate_DChannelE1(self.DChannelE1)    # validate type DChannelE1
# end class digitalE1


class DChannelE1(object):
    subclass = None
    superclass = None
    def __init__(self, mtuSize='', channelIndex='', valueOf_=''):
        self.mtuSize = mtuSize
        self.channelIndex = channelIndex
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DChannelE1.subclass:
            return DChannelE1.subclass(*args_, **kwargs_)
        else:
            return DChannelE1(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_mtuSize(self): return self.mtuSize
    def set_mtuSize(self, mtuSize): self.mtuSize = mtuSize
    def get_channelIndex(self): return self.channelIndex
    def set_channelIndex(self, channelIndex): self.channelIndex = channelIndex
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='DChannelE1'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='DChannelE1')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='DChannelE1'):
        outfile.write(' mtuSize="%s"' % (quote_attrib(self.get_mtuSize()), ))
        outfile.write(' channelIndex="%s"' % (quote_attrib(self.get_channelIndex()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='DChannelE1'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='DChannelE1'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('mtuSize = "%s",\n' % (self.get_mtuSize(),))
        showIndent(outfile, level)
        outfile.write('channelIndex = "%s",\n' % (self.get_channelIndex(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('mtuSize'):
            self.mtuSize = attrs.get('mtuSize').value
        if attrs.get('channelIndex'):
            self.channelIndex = attrs.get('channelIndex').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class DChannelE1


class VqeParameters(object):
    subclass = None
    superclass = None
    def __init__(self, EchoCancellation=None, AcousticEchoCancellation=None, LevelControl=None, BackgroundNoiseAttenuation=None, DTMFRemoval=None):
        self.EchoCancellation = EchoCancellation
        self.AcousticEchoCancellation = AcousticEchoCancellation
        self.LevelControl = LevelControl
        self.BackgroundNoiseAttenuation = BackgroundNoiseAttenuation
        self.DTMFRemoval = DTMFRemoval
    def factory(*args_, **kwargs_):
        if VqeParameters.subclass:
            return VqeParameters.subclass(*args_, **kwargs_)
        else:
            return VqeParameters(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_EchoCancellation(self): return self.EchoCancellation
    def set_EchoCancellation(self, EchoCancellation): self.EchoCancellation = EchoCancellation
    def validate_EchoCancellation(self, value):
        # validate type EchoCancellation
        pass
    def get_AcousticEchoCancellation(self): return self.AcousticEchoCancellation
    def set_AcousticEchoCancellation(self, AcousticEchoCancellation): self.AcousticEchoCancellation = AcousticEchoCancellation
    def validate_AcousticEchoCancellation(self, value):
        # validate type AcousticEchoCancellation
        pass
    def get_LevelControl(self): return self.LevelControl
    def set_LevelControl(self, LevelControl): self.LevelControl = LevelControl
    def validate_LevelControl(self, value):
        # validate type LevelControl
        pass
    def get_BackgroundNoiseAttenuation(self): return self.BackgroundNoiseAttenuation
    def set_BackgroundNoiseAttenuation(self, BackgroundNoiseAttenuation): self.BackgroundNoiseAttenuation = BackgroundNoiseAttenuation
    def validate_BackgroundNoiseAttenuation(self, value):
        # validate type BackgroundNoiseAttenuation
        pass
    def get_DTMFRemoval(self): return self.DTMFRemoval
    def set_DTMFRemoval(self, DTMFRemoval): self.DTMFRemoval = DTMFRemoval
    def validate_DTMFRemoval(self, value):
        # validate type DTMFRemoval
        pass
    def export(self, outfile, level, namespace_='', name_='VqeParameters'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='VqeParameters')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='VqeParameters'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='VqeParameters'):
        if self.get_EchoCancellation() != None :
            if self.EchoCancellation:
                self.EchoCancellation.export(outfile, level, namespace_, name_='EchoCancellation')
        if self.get_AcousticEchoCancellation() != None :
            if self.AcousticEchoCancellation:
                self.AcousticEchoCancellation.export(outfile, level, namespace_, name_='AcousticEchoCancellation')
        if self.get_LevelControl() != None :
            if self.LevelControl:
                self.LevelControl.export(outfile, level, namespace_, name_='LevelControl')
        if self.get_BackgroundNoiseAttenuation() != None :
            if self.BackgroundNoiseAttenuation:
                self.BackgroundNoiseAttenuation.export(outfile, level, namespace_, name_='BackgroundNoiseAttenuation')
        if self.get_DTMFRemoval() != None :
            if self.DTMFRemoval:
                self.DTMFRemoval.export(outfile, level, namespace_, name_='DTMFRemoval')
    def exportLiteral(self, outfile, level, name_='VqeParameters'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.EchoCancellation:
            showIndent(outfile, level)
            outfile.write('EchoCancellation=EchoCancellation(\n')
            self.EchoCancellation.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.AcousticEchoCancellation:
            showIndent(outfile, level)
            outfile.write('AcousticEchoCancellation=AcousticEchoCancellation(\n')
            self.AcousticEchoCancellation.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.LevelControl:
            showIndent(outfile, level)
            outfile.write('LevelControl=LevelControl(\n')
            self.LevelControl.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.BackgroundNoiseAttenuation:
            showIndent(outfile, level)
            outfile.write('BackgroundNoiseAttenuation=BackgroundNoiseAttenuation(\n')
            self.BackgroundNoiseAttenuation.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.DTMFRemoval:
            showIndent(outfile, level)
            outfile.write('DTMFRemoval=DTMFRemoval(\n')
            self.DTMFRemoval.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'EchoCancellation':
            obj_ = EchoCancellation.factory()
            obj_.build(child_)
            self.set_EchoCancellation(obj_)
            self.validate_EchoCancellation(self.EchoCancellation)    # validate type EchoCancellation
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AcousticEchoCancellation':
            obj_ = AcousticEchoCancellation.factory()
            obj_.build(child_)
            self.set_AcousticEchoCancellation(obj_)
            self.validate_AcousticEchoCancellation(self.AcousticEchoCancellation)    # validate type AcousticEchoCancellation
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LevelControl':
            obj_ = LevelControl.factory()
            obj_.build(child_)
            self.set_LevelControl(obj_)
            self.validate_LevelControl(self.LevelControl)    # validate type LevelControl
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BackgroundNoiseAttenuation':
            obj_ = BackgroundNoiseAttenuation.factory()
            obj_.build(child_)
            self.set_BackgroundNoiseAttenuation(obj_)
            self.validate_BackgroundNoiseAttenuation(self.BackgroundNoiseAttenuation)    # validate type BackgroundNoiseAttenuation
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DTMFRemoval':
            obj_ = DTMFRemoval.factory()
            obj_.build(child_)
            self.set_DTMFRemoval(obj_)
            self.validate_DTMFRemoval(self.DTMFRemoval)    # validate type DTMFRemoval
# end class VqeParameters


class EchoCancellation(object):
    subclass = None
    superclass = None
    def __init__(self, doubleTalkBehavior='', tailDisplacementInMs='', typexx='', mode='', comfortNoiseMode='', valueOf_=''):
        self.doubleTalkBehavior = doubleTalkBehavior
        self.tailDisplacementInMs = tailDisplacementInMs
        self.typexx = typexx
        self.mode = mode
        self.comfortNoiseMode = comfortNoiseMode
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if EchoCancellation.subclass:
            return EchoCancellation.subclass(*args_, **kwargs_)
        else:
            return EchoCancellation(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_doubleTalkBehavior(self): return self.doubleTalkBehavior
    def set_doubleTalkBehavior(self, doubleTalkBehavior): self.doubleTalkBehavior = doubleTalkBehavior
    def get_tailDisplacementInMs(self): return self.tailDisplacementInMs
    def set_tailDisplacementInMs(self, tailDisplacementInMs): self.tailDisplacementInMs = tailDisplacementInMs
    def get_type(self): return self.typexx
    def set_type(self, typexx): self.typexx = typexx
    def get_mode(self): return self.mode
    def set_mode(self, mode): self.mode = mode
    def get_comfortNoiseMode(self): return self.comfortNoiseMode
    def set_comfortNoiseMode(self, comfortNoiseMode): self.comfortNoiseMode = comfortNoiseMode
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='EchoCancellation'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='EchoCancellation')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='EchoCancellation'):
        outfile.write(' doubleTalkBehavior="%s"' % (quote_attrib(self.get_doubleTalkBehavior()), ))
        outfile.write(' tailDisplacementInMs="%s"' % (quote_attrib(self.get_tailDisplacementInMs()), ))
        outfile.write(' type="%s"' % (quote_attrib(self.get_type()), ))
        outfile.write(' mode="%s"' % (quote_attrib(self.get_mode()), ))
        outfile.write(' comfortNoiseMode="%s"' % (quote_attrib(self.get_comfortNoiseMode()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='EchoCancellation'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='EchoCancellation'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('doubleTalkBehavior = "%s",\n' % (self.get_doubleTalkBehavior(),))
        showIndent(outfile, level)
        outfile.write('tailDisplacementInMs = "%s",\n' % (self.get_tailDisplacementInMs(),))
        showIndent(outfile, level)
        outfile.write('typexx = "%s",\n' % (self.get_type(),))
        showIndent(outfile, level)
        outfile.write('mode = "%s",\n' % (self.get_mode(),))
        showIndent(outfile, level)
        outfile.write('comfortNoiseMode = "%s",\n' % (self.get_comfortNoiseMode(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('doubleTalkBehavior'):
            self.doubleTalkBehavior = attrs.get('doubleTalkBehavior').value
        if attrs.get('tailDisplacementInMs'):
            self.tailDisplacementInMs = attrs.get('tailDisplacementInMs').value
        if attrs.get('type'):
            self.typexx = attrs.get('type').value
        if attrs.get('mode'):
            self.mode = attrs.get('mode').value
        if attrs.get('comfortNoiseMode'):
            self.comfortNoiseMode = attrs.get('comfortNoiseMode').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class EchoCancellation


class AcousticEchoCancellation(object):
    subclass = None
    superclass = None
    def __init__(self, typexx='', mode='', valueOf_=''):
        self.typexx = typexx
        self.mode = mode
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if AcousticEchoCancellation.subclass:
            return AcousticEchoCancellation.subclass(*args_, **kwargs_)
        else:
            return AcousticEchoCancellation(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_type(self): return self.typexx
    def set_type(self, typexx): self.typexx = typexx
    def get_mode(self): return self.mode
    def set_mode(self, mode): self.mode = mode
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='AcousticEchoCancellation'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='AcousticEchoCancellation')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='AcousticEchoCancellation'):
        outfile.write(' type="%s"' % (quote_attrib(self.get_type()), ))
        outfile.write(' mode="%s"' % (quote_attrib(self.get_mode()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='AcousticEchoCancellation'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='AcousticEchoCancellation'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('typexx = "%s",\n' % (self.get_type(),))
        showIndent(outfile, level)
        outfile.write('mode = "%s",\n' % (self.get_mode(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('type'):
            self.typexx = attrs.get('type').value
        if attrs.get('mode'):
            self.mode = attrs.get('mode').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class AcousticEchoCancellation


class LevelControl(object):
    subclass = None
    superclass = None
    def __init__(self, gainIndB=None, direction='', typexx='', mode='', targetLevelIndBM0=None, valueOf_=''):
        self.gainIndB = gainIndB
        self.direction = direction
        self.typexx = typexx
        self.mode = mode
        self.targetLevelIndBM0 = targetLevelIndBM0
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if LevelControl.subclass:
            return LevelControl.subclass(*args_, **kwargs_)
        else:
            return LevelControl(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_gainIndB(self): return self.gainIndB
    def set_gainIndB(self, gainIndB): self.gainIndB = gainIndB
    def get_direction(self): return self.direction
    def set_direction(self, direction): self.direction = direction
    def get_type(self): return self.typexx
    def set_type(self, typexx): self.typexx = typexx
    def get_mode(self): return self.mode
    def set_mode(self, mode): self.mode = mode
    def get_targetLevelIndBM0(self): return self.targetLevelIndBM0
    def set_targetLevelIndBM0(self, targetLevelIndBM0): self.targetLevelIndBM0 = targetLevelIndBM0
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='LevelControl'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='LevelControl')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='LevelControl'):
        if self.get_gainIndB() is not None:
            outfile.write(' gainIndB="%s"' % (quote_attrib(self.get_gainIndB()), ))
        outfile.write(' direction="%s"' % (quote_attrib(self.get_direction()), ))
        outfile.write(' type="%s"' % (quote_attrib(self.get_type()), ))
        outfile.write(' mode="%s"' % (quote_attrib(self.get_mode()), ))
        if self.get_targetLevelIndBM0() is not None:
            outfile.write(' targetLevelIndBM0="%s"' % (quote_attrib(self.get_targetLevelIndBM0()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='LevelControl'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='LevelControl'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('gainIndB = "%s",\n' % (self.get_gainIndB(),))
        showIndent(outfile, level)
        outfile.write('direction = "%s",\n' % (self.get_direction(),))
        showIndent(outfile, level)
        outfile.write('typexx = "%s",\n' % (self.get_type(),))
        showIndent(outfile, level)
        outfile.write('mode = "%s",\n' % (self.get_mode(),))
        showIndent(outfile, level)
        outfile.write('targetLevelIndBM0 = "%s",\n' % (self.get_targetLevelIndBM0(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('gainIndB'):
            self.gainIndB = attrs.get('gainIndB').value
        if attrs.get('direction'):
            self.direction = attrs.get('direction').value
        if attrs.get('type'):
            self.typexx = attrs.get('type').value
        if attrs.get('mode'):
            self.mode = attrs.get('mode').value
        if attrs.get('targetLevelIndBM0'):
            self.targetLevelIndBM0 = attrs.get('targetLevelIndBM0').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class LevelControl


class BackgroundNoiseAttenuation(object):
    subclass = None
    superclass = None
    def __init__(self, attenuationIndB='', direction='', typexx='', mode='', valueOf_=''):
        self.attenuationIndB = attenuationIndB
        self.direction = direction
        self.typexx = typexx
        self.mode = mode
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if BackgroundNoiseAttenuation.subclass:
            return BackgroundNoiseAttenuation.subclass(*args_, **kwargs_)
        else:
            return BackgroundNoiseAttenuation(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_attenuationIndB(self): return self.attenuationIndB
    def set_attenuationIndB(self, attenuationIndB): self.attenuationIndB = attenuationIndB
    def get_direction(self): return self.direction
    def set_direction(self, direction): self.direction = direction
    def get_type(self): return self.typexx
    def set_type(self, typexx): self.typexx = typexx
    def get_mode(self): return self.mode
    def set_mode(self, mode): self.mode = mode
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='BackgroundNoiseAttenuation'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='BackgroundNoiseAttenuation')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='BackgroundNoiseAttenuation'):
        outfile.write(' attenuationIndB="%s"' % (quote_attrib(self.get_attenuationIndB()), ))
        outfile.write(' direction="%s"' % (quote_attrib(self.get_direction()), ))
        outfile.write(' type="%s"' % (quote_attrib(self.get_type()), ))
        outfile.write(' mode="%s"' % (quote_attrib(self.get_mode()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='BackgroundNoiseAttenuation'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='BackgroundNoiseAttenuation'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('attenuationIndB = "%s",\n' % (self.get_attenuationIndB(),))
        showIndent(outfile, level)
        outfile.write('direction = "%s",\n' % (self.get_direction(),))
        showIndent(outfile, level)
        outfile.write('typexx = "%s",\n' % (self.get_type(),))
        showIndent(outfile, level)
        outfile.write('mode = "%s",\n' % (self.get_mode(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('attenuationIndB'):
            self.attenuationIndB = attrs.get('attenuationIndB').value
        if attrs.get('direction'):
            self.direction = attrs.get('direction').value
        if attrs.get('type'):
            self.typexx = attrs.get('type').value
        if attrs.get('mode'):
            self.mode = attrs.get('mode').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class BackgroundNoiseAttenuation


class DTMFRemoval(object):
    subclass = None
    superclass = None
    def __init__(self, direction='', typexx='', mode='', valueOf_=''):
        self.direction = direction
        self.typexx = typexx
        self.mode = mode
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DTMFRemoval.subclass:
            return DTMFRemoval.subclass(*args_, **kwargs_)
        else:
            return DTMFRemoval(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_direction(self): return self.direction
    def set_direction(self, direction): self.direction = direction
    def get_type(self): return self.typexx
    def set_type(self, typexx): self.typexx = typexx
    def get_mode(self): return self.mode
    def set_mode(self, mode): self.mode = mode
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='DTMFRemoval'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='DTMFRemoval')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='DTMFRemoval'):
        outfile.write(' direction="%s"' % (quote_attrib(self.get_direction()), ))
        outfile.write(' type="%s"' % (quote_attrib(self.get_type()), ))
        outfile.write(' mode="%s"' % (quote_attrib(self.get_mode()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='DTMFRemoval'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='DTMFRemoval'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('direction = "%s",\n' % (self.get_direction(),))
        showIndent(outfile, level)
        outfile.write('typexx = "%s",\n' % (self.get_type(),))
        showIndent(outfile, level)
        outfile.write('mode = "%s",\n' % (self.get_mode(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('direction'):
            self.direction = attrs.get('direction').value
        if attrs.get('type'):
            self.typexx = attrs.get('type').value
        if attrs.get('mode'):
            self.mode = attrs.get('mode').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class DTMFRemoval


class BChannelRange(object):
    subclass = None
    superclass = None
    def __init__(self, lastChannel='', channelGroupID='', firstChannel='', valueOf_=''):
        self.lastChannel = lastChannel
        self.channelGroupID = channelGroupID
        self.firstChannel = firstChannel
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if BChannelRange.subclass:
            return BChannelRange.subclass(*args_, **kwargs_)
        else:
            return BChannelRange(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_lastChannel(self): return self.lastChannel
    def set_lastChannel(self, lastChannel): self.lastChannel = lastChannel
    def get_channelGroupID(self): return self.channelGroupID
    def set_channelGroupID(self, channelGroupID): self.channelGroupID = channelGroupID
    def get_firstChannel(self): return self.firstChannel
    def set_firstChannel(self, firstChannel): self.firstChannel = firstChannel
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='BChannelRange'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='BChannelRange')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='BChannelRange'):
        outfile.write(' lastChannel="%s"' % (quote_attrib(self.get_lastChannel()), ))
        outfile.write(' channelGroupID="%s"' % (quote_attrib(self.get_channelGroupID()), ))
        outfile.write(' firstChannel="%s"' % (quote_attrib(self.get_firstChannel()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='BChannelRange'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='BChannelRange'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('lastChannel = "%s",\n' % (self.get_lastChannel(),))
        showIndent(outfile, level)
        outfile.write('channelGroupID = "%s",\n' % (self.get_channelGroupID(),))
        showIndent(outfile, level)
        outfile.write('firstChannel = "%s",\n' % (self.get_firstChannel(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('lastChannel'):
            self.lastChannel = attrs.get('lastChannel').value
        if attrs.get('channelGroupID'):
            self.channelGroupID = attrs.get('channelGroupID').value
        if attrs.get('firstChannel'):
            self.firstChannel = attrs.get('firstChannel').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class BChannelRange


class analogFxoConfig(object):
    subclass = None
    superclass = None
    def __init__(self, displayName='', ID=1, minimumOnHookDurationMs=1, inboundCallHandling=None, outboundCallHandling=None, disconnectSupervision=None, applyTo=None):
        self.displayName = displayName
        self.ID = ID
        self.minimumOnHookDurationMs = minimumOnHookDurationMs
        self.inboundCallHandling = inboundCallHandling
        self.outboundCallHandling = outboundCallHandling
        self.disconnectSupervision = disconnectSupervision
        self.applyTo = applyTo
    def factory(*args_, **kwargs_):
        if analogFxoConfig.subclass:
            return analogFxoConfig.subclass(*args_, **kwargs_)
        else:
            return analogFxoConfig(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_inboundCallHandling(self): return self.inboundCallHandling
    def set_inboundCallHandling(self, inboundCallHandling): self.inboundCallHandling = inboundCallHandling
    def get_outboundCallHandling(self): return self.outboundCallHandling
    def set_outboundCallHandling(self, outboundCallHandling): self.outboundCallHandling = outboundCallHandling
    def get_disconnectSupervision(self): return self.disconnectSupervision
    def set_disconnectSupervision(self, disconnectSupervision): self.disconnectSupervision = disconnectSupervision
    def get_applyTo(self): return self.applyTo
    def set_applyTo(self, applyTo): self.applyTo = applyTo
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def get_minimumOnHookDurationMs(self): return self.minimumOnHookDurationMs
    def set_minimumOnHookDurationMs(self, minimumOnHookDurationMs): self.minimumOnHookDurationMs = minimumOnHookDurationMs
    def export(self, outfile, level, namespace_='', name_='analogFxoConfig'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='analogFxoConfig')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='analogFxoConfig'):
        outfile.write(' displayName="%s"' % (quote_attrib(self.get_displayName()), ))
        outfile.write(' ID="%d"' % self.get_ID())
        outfile.write(' minimumOnHookDurationMs="%d"' % self.get_minimumOnHookDurationMs())
    def exportChildren(self, outfile, level, namespace_='', name_='analogFxoConfig'):
        if self.inboundCallHandling:
            self.inboundCallHandling.export(outfile, level, namespace_, name_='inboundCallHandling', )
        if self.outboundCallHandling:
            self.outboundCallHandling.export(outfile, level, namespace_, name_='outboundCallHandling', )
        if self.disconnectSupervision:
            self.disconnectSupervision.export(outfile, level, namespace_, name_='disconnectSupervision', )
        if self.applyTo:
            self.applyTo.export(outfile, level, namespace_, name_='applyTo', )
    def exportLiteral(self, outfile, level, name_='analogFxoConfig'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('displayName = "%s",\n' % (self.get_displayName(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
        showIndent(outfile, level)
        outfile.write('minimumOnHookDurationMs = "%s",\n' % (self.get_minimumOnHookDurationMs(),))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.inboundCallHandling:
            showIndent(outfile, level)
            outfile.write('inboundCallHandling=inboundCallHandling(\n')
            self.inboundCallHandling.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.outboundCallHandling:
            showIndent(outfile, level)
            outfile.write('outboundCallHandling=outboundCallHandling(\n')
            self.outboundCallHandling.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.disconnectSupervision:
            showIndent(outfile, level)
            outfile.write('disconnectSupervision=disconnectSupervision(\n')
            self.disconnectSupervision.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.applyTo:
            showIndent(outfile, level)
            outfile.write('applyTo=applyTo(\n')
            self.applyTo.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('displayName'):
            self.displayName = attrs.get('displayName').value
        if attrs.get('ID'):
            try:
                self.ID = int(attrs.get('ID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ID): %s' % exp)
            if self.ID <= 0:
                raise ValueError('Invalid PositiveInteger (ID)')
        if attrs.get('minimumOnHookDurationMs'):
            try:
                self.minimumOnHookDurationMs = int(attrs.get('minimumOnHookDurationMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (minimumOnHookDurationMs): %s' % exp)
            if self.minimumOnHookDurationMs <= 0:
                raise ValueError('Invalid PositiveInteger (minimumOnHookDurationMs)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'inboundCallHandling':
            obj_ = inboundCallHandling.factory()
            obj_.build(child_)
            self.set_inboundCallHandling(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'outboundCallHandling':
            obj_ = outboundCallHandling.factory()
            obj_.build(child_)
            self.set_outboundCallHandling(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disconnectSupervision':
            obj_ = disconnectSupervision.factory()
            obj_.build(child_)
            self.set_disconnectSupervision(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'applyTo':
            obj_ = applyTo.factory()
            obj_.build(child_)
            self.set_applyTo(obj_)
# end class analogFxoConfig


class inboundCallHandling(object):
    subclass = None
    superclass = None
    def __init__(self, notifyOutboundSide=None, connect=None, callerID=None):
        self.notifyOutboundSide = notifyOutboundSide
        self.connect = connect
        self.callerID = callerID
    def factory(*args_, **kwargs_):
        if inboundCallHandling.subclass:
            return inboundCallHandling.subclass(*args_, **kwargs_)
        else:
            return inboundCallHandling(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_notifyOutboundSide(self): return self.notifyOutboundSide
    def set_notifyOutboundSide(self, notifyOutboundSide): self.notifyOutboundSide = notifyOutboundSide
    def validate_notifyOutboundSide(self, value):
        # validate type notifyOutboundSide
        pass
    def get_connect(self): return self.connect
    def set_connect(self, connect): self.connect = connect
    def validate_connect(self, value):
        # validate type connect
        pass
    def get_callerID(self): return self.callerID
    def set_callerID(self, callerID): self.callerID = callerID
    def validate_callerID(self, value):
        # validate type callerID
        pass
    def export(self, outfile, level, namespace_='', name_='inboundCallHandling'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='inboundCallHandling')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='inboundCallHandling'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='inboundCallHandling'):
        if self.notifyOutboundSide:
            self.notifyOutboundSide.export(outfile, level, namespace_, name_='notifyOutboundSide', )
        if self.connect:
            self.connect.export(outfile, level, namespace_, name_='connect', )
        if self.callerID:
            self.callerID.export(outfile, level, namespace_, name_='callerID', )
    def exportLiteral(self, outfile, level, name_='inboundCallHandling'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.notifyOutboundSide:
            showIndent(outfile, level)
            outfile.write('notifyOutboundSide=notifyOutboundSide(\n')
            self.notifyOutboundSide.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.connect:
            showIndent(outfile, level)
            outfile.write('connect=connect(\n')
            self.connect.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.callerID:
            showIndent(outfile, level)
            outfile.write('callerID=callerID(\n')
            self.callerID.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'notifyOutboundSide':
            obj_ = notifyOutboundSide.factory()
            obj_.build(child_)
            self.set_notifyOutboundSide(obj_)
            self.validate_notifyOutboundSide(self.notifyOutboundSide)    # validate type notifyOutboundSide
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'connect':
            obj_ = connect.factory()
            obj_.build(child_)
            self.set_connect(obj_)
            self.validate_connect(self.connect)    # validate type connect
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'callerID':
            obj_ = callerID.factory()
            obj_.build(child_)
            self.set_callerID(obj_)
            self.validate_callerID(self.callerID)    # validate type callerID
# end class inboundCallHandling


class notifyOutboundSide(object):
    subclass = None
    superclass = None
    def __init__(self, numberOfRings=None, delayInMs=0, condition='', valueOf_=''):
        self.numberOfRings = numberOfRings
        self.delayInMs = delayInMs
        self.condition = condition
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if notifyOutboundSide.subclass:
            return notifyOutboundSide.subclass(*args_, **kwargs_)
        else:
            return notifyOutboundSide(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_numberOfRings(self): return self.numberOfRings
    def set_numberOfRings(self, numberOfRings): self.numberOfRings = numberOfRings
    def get_delayInMs(self): return self.delayInMs
    def set_delayInMs(self, delayInMs): self.delayInMs = delayInMs
    def get_condition(self): return self.condition
    def set_condition(self, condition): self.condition = condition
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='notifyOutboundSide'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='notifyOutboundSide')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='notifyOutboundSide'):
        if self.get_numberOfRings() is not None:
            outfile.write(' numberOfRings="%d"' % self.get_numberOfRings())
        outfile.write(' delayInMs="%d"' % self.get_delayInMs())
        outfile.write(' condition="%s"' % (quote_attrib(self.get_condition()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='notifyOutboundSide'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='notifyOutboundSide'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('numberOfRings = "%s",\n' % (self.get_numberOfRings(),))
        showIndent(outfile, level)
        outfile.write('delayInMs = "%s",\n' % (self.get_delayInMs(),))
        showIndent(outfile, level)
        outfile.write('condition = "%s",\n' % (self.get_condition(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('numberOfRings'):
            try:
                self.numberOfRings = int(attrs.get('numberOfRings').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (numberOfRings): %s' % exp)
            if self.numberOfRings < 0:
                raise ValueError('Invalid NonNegativeInteger (numberOfRings)')
        if attrs.get('delayInMs'):
            try:
                self.delayInMs = int(attrs.get('delayInMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (delayInMs): %s' % exp)
            if self.delayInMs < 0:
                raise ValueError('Invalid NonNegativeInteger (delayInMs)')
        if attrs.get('condition'):
            self.condition = attrs.get('condition').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class notifyOutboundSide


class callerID(object):
    subclass = None
    superclass = None
    def __init__(self, typexx='', valueOf_=''):
        self.typexx = typexx
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if callerID.subclass:
            return callerID.subclass(*args_, **kwargs_)
        else:
            return callerID(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_type(self): return self.typexx
    def set_type(self, typexx): self.typexx = typexx
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='callerID'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='callerID')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='callerID'):
        outfile.write(' type="%s"' % (quote_attrib(self.get_type()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='callerID'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='callerID'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('typexx = "%s",\n' % (self.get_type(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('type'):
            self.typexx = attrs.get('type').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class callerID


class outboundCallHandling(object):
    subclass = None
    superclass = None
    def __init__(self, dial=None, connectSupervision=None):
        if dial is None:
            self.dial = []
        else:
            self.dial = dial
        if connectSupervision is None:
            self.connectSupervision = []
        else:
            self.connectSupervision = connectSupervision
    def factory(*args_, **kwargs_):
        if outboundCallHandling.subclass:
            return outboundCallHandling.subclass(*args_, **kwargs_)
        else:
            return outboundCallHandling(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_dial(self): return self.dial
    def set_dial(self, dial): self.dial = dial
    def add_dial(self, value): self.dial.append(value)
    def insert_dial(self, index, value): self.dial[index] = value
    def validate_dial(self, value):
        # validate type dial
        pass
    def get_connectSupervision(self): return self.connectSupervision
    def set_connectSupervision(self, connectSupervision): self.connectSupervision = connectSupervision
    def add_connectSupervision(self, value): self.connectSupervision.append(value)
    def insert_connectSupervision(self, index, value): self.connectSupervision[index] = value
    def export(self, outfile, level, namespace_='', name_='outboundCallHandling'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='outboundCallHandling')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='outboundCallHandling'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='outboundCallHandling'):
        for dial_ in self.get_dial():
            dial_.export(outfile, level, namespace_, name_='dial')
        for connectSupervision_ in self.get_connectSupervision():
            connectSupervision_.export(outfile, level, namespace_, name_='connectSupervision')
    def exportLiteral(self, outfile, level, name_='outboundCallHandling'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('dial=[\n')
        level += 1
        for dial in self.dial:
            showIndent(outfile, level)
            outfile.write('dial(\n')
            dial.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('connectSupervision=[\n')
        level += 1
        for connectSupervision in self.connectSupervision:
            showIndent(outfile, level)
            outfile.write('connectSupervision(\n')
            connectSupervision.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'dial':
            obj_ = dial.factory()
            obj_.build(child_)
            self.dial.append(obj_)
            self.validate_dial(self.dial)    # validate type dial
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'connectSupervision':
            obj_ = connectSupervision.factory()
            obj_.build(child_)
            self.connectSupervision.append(obj_)
# end class outboundCallHandling


class dial(object):
    subclass = None
    superclass = None
    def __init__(self, active='', DTMFDigitDurationInMs=0, interDigitDelayInMs=0, waitForDialTone='', preDialDelayInMs=0, valueOf_=''):
        self.active = active
        self.DTMFDigitDurationInMs = DTMFDigitDurationInMs
        self.interDigitDelayInMs = interDigitDelayInMs
        self.waitForDialTone = waitForDialTone
        self.preDialDelayInMs = preDialDelayInMs
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if dial.subclass:
            return dial.subclass(*args_, **kwargs_)
        else:
            return dial(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_active(self): return self.active
    def set_active(self, active): self.active = active
    def get_DTMFDigitDurationInMs(self): return self.DTMFDigitDurationInMs
    def set_DTMFDigitDurationInMs(self, DTMFDigitDurationInMs): self.DTMFDigitDurationInMs = DTMFDigitDurationInMs
    def get_interDigitDelayInMs(self): return self.interDigitDelayInMs
    def set_interDigitDelayInMs(self, interDigitDelayInMs): self.interDigitDelayInMs = interDigitDelayInMs
    def get_waitForDialTone(self): return self.waitForDialTone
    def set_waitForDialTone(self, waitForDialTone): self.waitForDialTone = waitForDialTone
    def get_preDialDelayInMs(self): return self.preDialDelayInMs
    def set_preDialDelayInMs(self, preDialDelayInMs): self.preDialDelayInMs = preDialDelayInMs
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='dial'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='dial')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='dial'):
        outfile.write(' active="%s"' % (quote_attrib(self.get_active()), ))
        outfile.write(' DTMFDigitDurationInMs="%d"' % self.get_DTMFDigitDurationInMs())
        outfile.write(' interDigitDelayInMs="%d"' % self.get_interDigitDelayInMs())
        outfile.write(' waitForDialTone="%s"' % (quote_attrib(self.get_waitForDialTone()), ))
        outfile.write(' preDialDelayInMs="%d"' % self.get_preDialDelayInMs())
    def exportChildren(self, outfile, level, namespace_='', name_='dial'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='dial'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('active = "%s",\n' % (self.get_active(),))
        showIndent(outfile, level)
        outfile.write('DTMFDigitDurationInMs = "%s",\n' % (self.get_DTMFDigitDurationInMs(),))
        showIndent(outfile, level)
        outfile.write('interDigitDelayInMs = "%s",\n' % (self.get_interDigitDelayInMs(),))
        showIndent(outfile, level)
        outfile.write('waitForDialTone = "%s",\n' % (self.get_waitForDialTone(),))
        showIndent(outfile, level)
        outfile.write('preDialDelayInMs = "%s",\n' % (self.get_preDialDelayInMs(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('active'):
            self.active = attrs.get('active').value
        if attrs.get('DTMFDigitDurationInMs'):
            try:
                self.DTMFDigitDurationInMs = int(attrs.get('DTMFDigitDurationInMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (DTMFDigitDurationInMs): %s' % exp)
            if self.DTMFDigitDurationInMs < 0:
                raise ValueError('Invalid NonNegativeInteger (DTMFDigitDurationInMs)')
        if attrs.get('interDigitDelayInMs'):
            try:
                self.interDigitDelayInMs = int(attrs.get('interDigitDelayInMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (interDigitDelayInMs): %s' % exp)
            if self.interDigitDelayInMs < 0:
                raise ValueError('Invalid NonNegativeInteger (interDigitDelayInMs)')
        if attrs.get('waitForDialTone'):
            self.waitForDialTone = attrs.get('waitForDialTone').value
        if attrs.get('preDialDelayInMs'):
            try:
                self.preDialDelayInMs = int(attrs.get('preDialDelayInMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (preDialDelayInMs): %s' % exp)
            if self.preDialDelayInMs < 0:
                raise ValueError('Invalid NonNegativeInteger (preDialDelayInMs)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class dial


class connectSupervision(object):
    subclass = None
    superclass = None
    def __init__(self, connectOutboundSide=None, connect=None):
        self.connectOutboundSide = connectOutboundSide
        self.connect = connect
    def factory(*args_, **kwargs_):
        if connectSupervision.subclass:
            return connectSupervision.subclass(*args_, **kwargs_)
        else:
            return connectSupervision(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_connectOutboundSide(self): return self.connectOutboundSide
    def set_connectOutboundSide(self, connectOutboundSide): self.connectOutboundSide = connectOutboundSide
    def validate_connectOutboundSide(self, value):
        # validate type connectOutboundSide
        pass
    def get_connect(self): return self.connect
    def set_connect(self, connect): self.connect = connect
    def validate_connect(self, value):
        # validate type connect
        pass
    def export(self, outfile, level, namespace_='', name_='connectSupervision'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='connectSupervision')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='connectSupervision'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='connectSupervision'):
        if self.connectOutboundSide:
            self.connectOutboundSide.export(outfile, level, namespace_, name_='connectOutboundSide', )
        if self.connect:
            self.connect.export(outfile, level, namespace_, name_='connect', )
    def exportLiteral(self, outfile, level, name_='connectSupervision'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.connectOutboundSide:
            showIndent(outfile, level)
            outfile.write('connectOutboundSide=connectOutboundSide(\n')
            self.connectOutboundSide.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.connect:
            showIndent(outfile, level)
            outfile.write('connect=connect(\n')
            self.connect.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'connectOutboundSide':
            obj_ = connectOutboundSide.factory()
            obj_.build(child_)
            self.set_connectOutboundSide(obj_)
            self.validate_connectOutboundSide(self.connectOutboundSide)    # validate type connectOutboundSide
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'connect':
            obj_ = connect.factory()
            obj_.build(child_)
            self.set_connect(obj_)
            self.validate_connect(self.connect)    # validate type connect
# end class connectSupervision


class connectOutboundSide(object):
    subclass = None
    superclass = None
    def __init__(self, disconnectTimeoutMs=None, condition='', connectOnNoRemoteRingTimeoutMs=None, valueOf_=''):
        self.disconnectTimeoutMs = disconnectTimeoutMs
        self.condition = condition
        self.connectOnNoRemoteRingTimeoutMs = connectOnNoRemoteRingTimeoutMs
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if connectOutboundSide.subclass:
            return connectOutboundSide.subclass(*args_, **kwargs_)
        else:
            return connectOutboundSide(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_disconnectTimeoutMs(self): return self.disconnectTimeoutMs
    def set_disconnectTimeoutMs(self, disconnectTimeoutMs): self.disconnectTimeoutMs = disconnectTimeoutMs
    def get_condition(self): return self.condition
    def set_condition(self, condition): self.condition = condition
    def get_connectOnNoRemoteRingTimeoutMs(self): return self.connectOnNoRemoteRingTimeoutMs
    def set_connectOnNoRemoteRingTimeoutMs(self, connectOnNoRemoteRingTimeoutMs): self.connectOnNoRemoteRingTimeoutMs = connectOnNoRemoteRingTimeoutMs
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='connectOutboundSide'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='connectOutboundSide')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='connectOutboundSide'):
        if self.get_disconnectTimeoutMs() is not None:
            outfile.write(' disconnectTimeoutMs="%d"' % self.get_disconnectTimeoutMs())
        outfile.write(' condition="%s"' % (quote_attrib(self.get_condition()), ))
        if self.get_connectOnNoRemoteRingTimeoutMs() is not None:
            outfile.write(' connectOnNoRemoteRingTimeoutMs="%d"' % self.get_connectOnNoRemoteRingTimeoutMs())
    def exportChildren(self, outfile, level, namespace_='', name_='connectOutboundSide'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='connectOutboundSide'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('disconnectTimeoutMs = "%s",\n' % (self.get_disconnectTimeoutMs(),))
        showIndent(outfile, level)
        outfile.write('condition = "%s",\n' % (self.get_condition(),))
        showIndent(outfile, level)
        outfile.write('connectOnNoRemoteRingTimeoutMs = "%s",\n' % (self.get_connectOnNoRemoteRingTimeoutMs(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('disconnectTimeoutMs'):
            try:
                self.disconnectTimeoutMs = int(attrs.get('disconnectTimeoutMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (disconnectTimeoutMs): %s' % exp)
            if self.disconnectTimeoutMs < 0:
                raise ValueError('Invalid NonNegativeInteger (disconnectTimeoutMs)')
        if attrs.get('condition'):
            self.condition = attrs.get('condition').value
        if attrs.get('connectOnNoRemoteRingTimeoutMs'):
            try:
                self.connectOnNoRemoteRingTimeoutMs = int(attrs.get('connectOnNoRemoteRingTimeoutMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (connectOnNoRemoteRingTimeoutMs): %s' % exp)
            if self.connectOnNoRemoteRingTimeoutMs < 0:
                raise ValueError('Invalid NonNegativeInteger (connectOnNoRemoteRingTimeoutMs)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class connectOutboundSide


class disconnectSupervision(object):
    subclass = None
    superclass = None
    def __init__(self, disconnectDetectors=None):
        self.disconnectDetectors = disconnectDetectors
    def factory(*args_, **kwargs_):
        if disconnectSupervision.subclass:
            return disconnectSupervision.subclass(*args_, **kwargs_)
        else:
            return disconnectSupervision(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_disconnectDetectors(self): return self.disconnectDetectors
    def set_disconnectDetectors(self, disconnectDetectors): self.disconnectDetectors = disconnectDetectors
    def export(self, outfile, level, namespace_='', name_='disconnectSupervision'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='disconnectSupervision')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='disconnectSupervision'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='disconnectSupervision'):
        if self.disconnectDetectors:
            self.disconnectDetectors.export(outfile, level, namespace_, name_='disconnectDetectors', )
    def exportLiteral(self, outfile, level, name_='disconnectSupervision'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.disconnectDetectors:
            showIndent(outfile, level)
            outfile.write('disconnectDetectors=disconnectDetectors(\n')
            self.disconnectDetectors.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'disconnectDetectors':
            obj_ = disconnectDetectors.factory()
            obj_.build(child_)
            self.set_disconnectDetectors(obj_)
# end class disconnectSupervision


class disconnectDetectors(object):
    subclass = None
    superclass = None
    def __init__(self, ringCadenceDetector=None, detector=None):
        self.ringCadenceDetector = ringCadenceDetector
        if detector is None:
            self.detector = []
        else:
            self.detector = detector
    def factory(*args_, **kwargs_):
        if disconnectDetectors.subclass:
            return disconnectDetectors.subclass(*args_, **kwargs_)
        else:
            return disconnectDetectors(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_ringCadenceDetector(self): return self.ringCadenceDetector
    def set_ringCadenceDetector(self, ringCadenceDetector): self.ringCadenceDetector = ringCadenceDetector
    def validate_ringCadenceDetector(self, value):
        # validate type ringCadenceDetector
        pass
    def get_detector(self): return self.detector
    def set_detector(self, detector): self.detector = detector
    def add_detector(self, value): self.detector.append(value)
    def insert_detector(self, index, value): self.detector[index] = value
    def export(self, outfile, level, namespace_='', name_='disconnectDetectors'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='disconnectDetectors')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='disconnectDetectors'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='disconnectDetectors'):
        if self.get_ringCadenceDetector() != None :
            if self.ringCadenceDetector:
                self.ringCadenceDetector.export(outfile, level, namespace_, name_='ringCadenceDetector')
        for detector_ in self.get_detector():
            detector_.export(outfile, level, namespace_, name_='detector')
    def exportLiteral(self, outfile, level, name_='disconnectDetectors'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.ringCadenceDetector:
            showIndent(outfile, level)
            outfile.write('ringCadenceDetector=ringCadenceDetector(\n')
            self.ringCadenceDetector.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        showIndent(outfile, level)
        outfile.write('detector=[\n')
        level += 1
        for detector in self.detector:
            showIndent(outfile, level)
            outfile.write('detector(\n')
            detector.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ringCadenceDetector':
            obj_ = ringCadenceDetector.factory()
            obj_.build(child_)
            self.set_ringCadenceDetector(obj_)
            self.validate_ringCadenceDetector(self.ringCadenceDetector)    # validate type ringCadenceDetector
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'detector':
            obj_ = detector.factory()
            obj_.build(child_)
            self.detector.append(obj_)
# end class disconnectDetectors


class ringCadenceDetector(object):
    subclass = None
    superclass = None
    def __init__(self, active='', ringCadenceOffDelayMs=None, valueOf_=''):
        self.active = active
        self.ringCadenceOffDelayMs = ringCadenceOffDelayMs
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ringCadenceDetector.subclass:
            return ringCadenceDetector.subclass(*args_, **kwargs_)
        else:
            return ringCadenceDetector(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_active(self): return self.active
    def set_active(self, active): self.active = active
    def get_ringCadenceOffDelayMs(self): return self.ringCadenceOffDelayMs
    def set_ringCadenceOffDelayMs(self, ringCadenceOffDelayMs): self.ringCadenceOffDelayMs = ringCadenceOffDelayMs
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='ringCadenceDetector'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='ringCadenceDetector')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='ringCadenceDetector'):
        outfile.write(' active="%s"' % (quote_attrib(self.get_active()), ))
        if self.get_ringCadenceOffDelayMs() is not None:
            outfile.write(' ringCadenceOffDelayMs="%d"' % self.get_ringCadenceOffDelayMs())
    def exportChildren(self, outfile, level, namespace_='', name_='ringCadenceDetector'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='ringCadenceDetector'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('active = "%s",\n' % (self.get_active(),))
        showIndent(outfile, level)
        outfile.write('ringCadenceOffDelayMs = "%s",\n' % (self.get_ringCadenceOffDelayMs(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('active'):
            self.active = attrs.get('active').value
        if attrs.get('ringCadenceOffDelayMs'):
            try:
                self.ringCadenceOffDelayMs = int(attrs.get('ringCadenceOffDelayMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ringCadenceOffDelayMs): %s' % exp)
            if self.ringCadenceOffDelayMs < 0:
                raise ValueError('Invalid NonNegativeInteger (ringCadenceOffDelayMs)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class ringCadenceDetector


class detector(object):
    subclass = None
    superclass = None
    def __init__(self, name='', sequence='', valueOf_=''):
        self.name = name
        self.sequence = sequence
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if detector.subclass:
            return detector.subclass(*args_, **kwargs_)
        else:
            return detector(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_name(self): return self.name
    def set_name(self, name): self.name = name
    def get_sequence(self): return self.sequence
    def set_sequence(self, sequence): self.sequence = sequence
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='detector'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='detector')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='detector'):
        outfile.write(' name="%s"' % (quote_attrib(self.get_name()), ))
        outfile.write(' sequence="%s"' % (quote_attrib(self.get_sequence()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='detector'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='detector'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('name = "%s",\n' % (self.get_name(),))
        showIndent(outfile, level)
        outfile.write('sequence = "%s",\n' % (self.get_sequence(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('name'):
            self.name = attrs.get('name').value
        if attrs.get('sequence'):
            self.sequence = attrs.get('sequence').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class detector


class analogFxsConfig(object):
    subclass = None
    superclass = None
    def __init__(self, displayName='', ID=1, applyTo=None):
        self.displayName = displayName
        self.ID = ID
        self.applyTo = applyTo
    def factory(*args_, **kwargs_):
        if analogFxsConfig.subclass:
            return analogFxsConfig.subclass(*args_, **kwargs_)
        else:
            return analogFxsConfig(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_applyTo(self): return self.applyTo
    def set_applyTo(self, applyTo): self.applyTo = applyTo
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def export(self, outfile, level, namespace_='', name_='analogFxsConfig'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='analogFxsConfig')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='analogFxsConfig'):
        outfile.write(' displayName="%s"' % (quote_attrib(self.get_displayName()), ))
        outfile.write(' ID="%d"' % self.get_ID())
    def exportChildren(self, outfile, level, namespace_='', name_='analogFxsConfig'):
        if self.applyTo:
            self.applyTo.export(outfile, level, namespace_, name_='applyTo', )
    def exportLiteral(self, outfile, level, name_='analogFxsConfig'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('displayName = "%s",\n' % (self.get_displayName(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
    def exportLiteralChildren(self, outfile, level, name_):
        if self.applyTo:
            showIndent(outfile, level)
            outfile.write('applyTo=applyTo(\n')
            self.applyTo.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('displayName'):
            self.displayName = attrs.get('displayName').value
        if attrs.get('ID'):
            try:
                self.ID = int(attrs.get('ID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ID): %s' % exp)
            if self.ID <= 0:
                raise ValueError('Invalid PositiveInteger (ID)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'applyTo':
            obj_ = applyTo.factory()
            obj_.build(child_)
            self.set_applyTo(obj_)
# end class analogFxsConfig


class sangomaInterfacesCommon(object):
    subclass = None
    superclass = None
    def __init__(self, interface=None):
        if interface is None:
            self.interface = []
        else:
            self.interface = interface
    def factory(*args_, **kwargs_):
        if sangomaInterfacesCommon.subclass:
            return sangomaInterfacesCommon.subclass(*args_, **kwargs_)
        else:
            return sangomaInterfacesCommon(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_interface(self): return self.interface
    def set_interface(self, interface): self.interface = interface
    def add_interface(self, value): self.interface.append(value)
    def insert_interface(self, index, value): self.interface[index] = value
    def validate_interface(self, value):
        # validate type interface
        pass
    def export(self, outfile, level, namespace_='', name_='sangomaInterfacesCommon'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='sangomaInterfacesCommon')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='sangomaInterfacesCommon'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='sangomaInterfacesCommon'):
        for interface_ in self.get_interface():
            interface_.export(outfile, level, namespace_, name_='interface')
    def exportLiteral(self, outfile, level, name_='sangomaInterfacesCommon'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('interface=[\n')
        level += 1
        for interface in self.interface:
            showIndent(outfile, level)
            outfile.write('interface(\n')
            interface.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'interface':
            obj_ = interface.factory()
            obj_.build(child_)
            self.interface.append(obj_)
            self.validate_interface(self.interface)    # validate type interface
# end class sangomaInterfacesCommon


class interface(object):
    subclass = None
    superclass = None
    def __init__(self, displayName='', peerVirtualInterfaceID=None, wanpipe=None, peerVirtualBoardID=None, wanpipeInterface=None, primaryClockReference=None, typexx=None, ID=1, valueOf_=''):
        self.displayName = displayName
        self.peerVirtualInterfaceID = peerVirtualInterfaceID
        self.wanpipe = wanpipe
        self.peerVirtualBoardID = peerVirtualBoardID
        self.wanpipeInterface = wanpipeInterface
        self.primaryClockReference = primaryClockReference
        self.typexx = typexx
        self.ID = ID
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if interface.subclass:
            return interface.subclass(*args_, **kwargs_)
        else:
            return interface(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    def get_peerVirtualInterfaceID(self): return self.peerVirtualInterfaceID
    def set_peerVirtualInterfaceID(self, peerVirtualInterfaceID): self.peerVirtualInterfaceID = peerVirtualInterfaceID
    def get_wanpipe(self): return self.wanpipe
    def set_wanpipe(self, wanpipe): self.wanpipe = wanpipe
    def get_peerVirtualBoardID(self): return self.peerVirtualBoardID
    def set_peerVirtualBoardID(self, peerVirtualBoardID): self.peerVirtualBoardID = peerVirtualBoardID
    def get_wanpipeInterface(self): return self.wanpipeInterface
    def set_wanpipeInterface(self, wanpipeInterface): self.wanpipeInterface = wanpipeInterface
    def get_primaryClockReference(self): return self.primaryClockReference
    def set_primaryClockReference(self, primaryClockReference): self.primaryClockReference = primaryClockReference
    def get_type(self): return self.typexx
    def set_type(self, typexx): self.typexx = typexx
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='interface'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='interface')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='interface'):
        outfile.write(' displayName="%s"' % (quote_attrib(self.get_displayName()), ))
        if self.get_peerVirtualInterfaceID() is not None:
            outfile.write(' peerVirtualInterfaceID="%d"' % self.get_peerVirtualInterfaceID())
        if self.get_wanpipe() is not None:
            outfile.write(' wanpipe="%d"' % self.get_wanpipe())
        if self.get_peerVirtualBoardID() is not None:
            outfile.write(' peerVirtualBoardID="%d"' % self.get_peerVirtualBoardID())
        if self.get_wanpipeInterface() is not None:
            outfile.write(' wanpipeInterface="%d"' % self.get_wanpipeInterface())
        if self.get_primaryClockReference() is not None:
            outfile.write(' primaryClockReference="%s"' % str(self.get_primaryClockReference()))
        if self.get_type() is not None:
            outfile.write(' type="%s"' % (quote_attrib(self.get_type()), ))
        outfile.write(' ID="%d"' % self.get_ID())
    def exportChildren(self, outfile, level, namespace_='', name_='interface'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='interface'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('displayName = "%s",\n' % (self.get_displayName(),))
        showIndent(outfile, level)
        outfile.write('peerVirtualInterfaceID = "%s",\n' % (self.get_peerVirtualInterfaceID(),))
        showIndent(outfile, level)
        outfile.write('wanpipe = "%s",\n' % (self.get_wanpipe(),))
        showIndent(outfile, level)
        outfile.write('peerVirtualBoardID = "%s",\n' % (self.get_peerVirtualBoardID(),))
        showIndent(outfile, level)
        outfile.write('wanpipeInterface = "%s",\n' % (self.get_wanpipeInterface(),))
        showIndent(outfile, level)
        outfile.write('primaryClockReference = "%s",\n' % (self.get_primaryClockReference(),))
        showIndent(outfile, level)
        outfile.write('typexx = "%s",\n' % (self.get_type(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('displayName'):
            self.displayName = attrs.get('displayName').value
        if attrs.get('peerVirtualInterfaceID'):
            try:
                self.peerVirtualInterfaceID = int(attrs.get('peerVirtualInterfaceID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (peerVirtualInterfaceID): %s' % exp)
            if self.peerVirtualInterfaceID <= 0:
                raise ValueError('Invalid PositiveInteger (peerVirtualInterfaceID)')
        if attrs.get('wanpipe'):
            try:
                self.wanpipe = int(attrs.get('wanpipe').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (wanpipe): %s' % exp)
            if self.wanpipe <= 0:
                raise ValueError('Invalid PositiveInteger (wanpipe)')
        if attrs.get('peerVirtualBoardID'):
            try:
                self.peerVirtualBoardID = int(attrs.get('peerVirtualBoardID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (peerVirtualBoardID): %s' % exp)
            if self.peerVirtualBoardID <= 0:
                raise ValueError('Invalid PositiveInteger (peerVirtualBoardID)')
        if attrs.get('wanpipeInterface'):
            try:
                self.wanpipeInterface = int(attrs.get('wanpipeInterface').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (wanpipeInterface): %s' % exp)
            if self.wanpipeInterface < 0:
                raise ValueError('Invalid NonNegativeInteger (wanpipeInterface)')
        if attrs.get('primaryClockReference'):
            self.primaryClockReference = attrs.get('primaryClockReference').value
        if attrs.get('type'):
            self.typexx = attrs.get('type').value
        if attrs.get('ID'):
            try:
                self.ID = int(attrs.get('ID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ID): %s' % exp)
            if self.ID <= 0:
                raise ValueError('Invalid PositiveInteger (ID)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class interface


class interfaceRef(object):
    subclass = None
    superclass = None
    def __init__(self, boardID=1, nfasInterfaceID=None, channelGroupID=None, DChannelMode=None, interfaceID=None, BChannelRange=None):
        self.boardID = boardID
        self.nfasInterfaceID = nfasInterfaceID
        self.channelGroupID = channelGroupID
        self.DChannelMode = DChannelMode
        self.interfaceID = interfaceID
        if BChannelRange is None:
            self.BChannelRange = []
        else:
            self.BChannelRange = BChannelRange
    def factory(*args_, **kwargs_):
        if interfaceRef.subclass:
            return interfaceRef.subclass(*args_, **kwargs_)
        else:
            return interfaceRef(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_BChannelRange(self): return self.BChannelRange
    def set_BChannelRange(self, BChannelRange): self.BChannelRange = BChannelRange
    def add_BChannelRange(self, value): self.BChannelRange.append(value)
    def insert_BChannelRange(self, index, value): self.BChannelRange[index] = value
    def validate_BChannelRange(self, value):
        # validate type BChannelRange
        pass
    def get_boardID(self): return self.boardID
    def set_boardID(self, boardID): self.boardID = boardID
    def get_nfasInterfaceID(self): return self.nfasInterfaceID
    def set_nfasInterfaceID(self, nfasInterfaceID): self.nfasInterfaceID = nfasInterfaceID
    def get_channelGroupID(self): return self.channelGroupID
    def set_channelGroupID(self, channelGroupID): self.channelGroupID = channelGroupID
    def get_DChannelMode(self): return self.DChannelMode
    def set_DChannelMode(self, DChannelMode): self.DChannelMode = DChannelMode
    def get_interfaceID(self): return self.interfaceID
    def set_interfaceID(self, interfaceID): self.interfaceID = interfaceID
    def export(self, outfile, level, namespace_='', name_='interfaceRef'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='interfaceRef')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='interfaceRef'):
        outfile.write(' boardID="%d"' % self.get_boardID())
        if self.get_nfasInterfaceID() is not None:
            outfile.write(' nfasInterfaceID="%s"' % str(self.get_nfasInterfaceID()))
        if self.get_channelGroupID() is not None:
            outfile.write(' channelGroupID="%s"' % (quote_attrib(self.get_channelGroupID()), ))
        if self.get_DChannelMode() is not None:
            outfile.write(' DChannelMode="%s"' % (quote_attrib(self.get_DChannelMode()), ))
        if self.get_interfaceID() is not None:
            outfile.write(' interfaceID="%d"' % self.get_interfaceID())
    def exportChildren(self, outfile, level, namespace_='', name_='interfaceRef'):
        for BChannelRange_ in self.get_BChannelRange():
            BChannelRange_.export(outfile, level, namespace_, name_='BChannelRange')
    def exportLiteral(self, outfile, level, name_='interfaceRef'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('boardID = "%s",\n' % (self.get_boardID(),))
        showIndent(outfile, level)
        outfile.write('nfasInterfaceID = "%s",\n' % (self.get_nfasInterfaceID(),))
        showIndent(outfile, level)
        outfile.write('channelGroupID = "%s",\n' % (self.get_channelGroupID(),))
        showIndent(outfile, level)
        outfile.write('DChannelMode = "%s",\n' % (self.get_DChannelMode(),))
        showIndent(outfile, level)
        outfile.write('interfaceID = "%s",\n' % (self.get_interfaceID(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('BChannelRange=[\n')
        level += 1
        for BChannelRange in self.BChannelRange:
            showIndent(outfile, level)
            outfile.write('BChannelRange(\n')
            BChannelRange.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('boardID'):
            try:
                self.boardID = int(attrs.get('boardID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (boardID): %s' % exp)
            if self.boardID <= 0:
                raise ValueError('Invalid PositiveInteger (boardID)')
        if attrs.get('nfasInterfaceID'):
            self.nfasInterfaceID = attrs.get('nfasInterfaceID').value
        if attrs.get('channelGroupID'):
            self.channelGroupID = attrs.get('channelGroupID').value
        if attrs.get('DChannelMode'):
            self.DChannelMode = attrs.get('DChannelMode').value
        if attrs.get('interfaceID'):
            try:
                self.interfaceID = int(attrs.get('interfaceID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (interfaceID): %s' % exp)
            if self.interfaceID <= 0:
                raise ValueError('Invalid PositiveInteger (interfaceID)')
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BChannelRange':
            obj_ = BChannelRange.factory()
            obj_.build(child_)
            self.BChannelRange.append(obj_)
            self.validate_BChannelRange(self.BChannelRange)    # validate type BChannelRange
# end class interfaceRef


class sangomaDigitalInterfaces(sangomaInterfacesCommon):
    subclass = None
    superclass = sangomaInterfacesCommon
    def __init__(self, interface=None, valueOf_=''):
        sangomaInterfacesCommon.__init__(self, interface)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if sangomaDigitalInterfaces.subclass:
            return sangomaDigitalInterfaces.subclass(*args_, **kwargs_)
        else:
            return sangomaDigitalInterfaces(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='sangomaDigitalInterfaces'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='sangomaDigitalInterfaces')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='sangomaDigitalInterfaces'):
        sangomaInterfacesCommon.exportAttributes(self, outfile, level, namespace_, name_='sangomaDigitalInterfaces')
    def exportChildren(self, outfile, level, namespace_='', name_='sangomaDigitalInterfaces'):
        sangomaInterfacesCommon.exportChildren(self, outfile, level, namespace_, name_)
    def exportLiteral(self, outfile, level, name_='sangomaDigitalInterfaces'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        sangomaInterfacesCommon.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        sangomaInterfacesCommon.exportLiteralChildren(self, outfile, level, name_)
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        sangomaInterfacesCommon.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        sangomaInterfacesCommon.buildChildren(self, child_, nodeName_)
# end class sangomaDigitalInterfaces


class sangomaVirtualDigitalInterfaces(sangomaInterfacesCommon):
    subclass = None
    superclass = sangomaInterfacesCommon
    def __init__(self, interface=None, valueOf_=''):
        sangomaInterfacesCommon.__init__(self, interface)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if sangomaVirtualDigitalInterfaces.subclass:
            return sangomaVirtualDigitalInterfaces.subclass(*args_, **kwargs_)
        else:
            return sangomaVirtualDigitalInterfaces(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='sangomaVirtualDigitalInterfaces'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='sangomaVirtualDigitalInterfaces')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='sangomaVirtualDigitalInterfaces'):
        sangomaInterfacesCommon.exportAttributes(self, outfile, level, namespace_, name_='sangomaVirtualDigitalInterfaces')
    def exportChildren(self, outfile, level, namespace_='', name_='sangomaVirtualDigitalInterfaces'):
        sangomaInterfacesCommon.exportChildren(self, outfile, level, namespace_, name_)
    def exportLiteral(self, outfile, level, name_='sangomaVirtualDigitalInterfaces'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        sangomaInterfacesCommon.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        sangomaInterfacesCommon.exportLiteralChildren(self, outfile, level, name_)
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        sangomaInterfacesCommon.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        sangomaInterfacesCommon.buildChildren(self, child_, nodeName_)
# end class sangomaVirtualDigitalInterfaces


class sangomaAnalogInterfaces(sangomaInterfacesCommon):
    subclass = None
    superclass = sangomaInterfacesCommon
    def __init__(self, interface=None, valueOf_=''):
        sangomaInterfacesCommon.__init__(self, interface)
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if sangomaAnalogInterfaces.subclass:
            return sangomaAnalogInterfaces.subclass(*args_, **kwargs_)
        else:
            return sangomaAnalogInterfaces(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='sangomaAnalogInterfaces'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='sangomaAnalogInterfaces')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='sangomaAnalogInterfaces'):
        sangomaInterfacesCommon.exportAttributes(self, outfile, level, namespace_, name_='sangomaAnalogInterfaces')
    def exportChildren(self, outfile, level, namespace_='', name_='sangomaAnalogInterfaces'):
        sangomaInterfacesCommon.exportChildren(self, outfile, level, namespace_, name_)
    def exportLiteral(self, outfile, level, name_='sangomaAnalogInterfaces'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
        sangomaInterfacesCommon.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        sangomaInterfacesCommon.exportLiteralChildren(self, outfile, level, name_)
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        sangomaInterfacesCommon.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        sangomaInterfacesCommon.buildChildren(self, child_, nodeName_)
# end class sangomaAnalogInterfaces


class dummy1(object):
    subclass = None
    superclass = None
    def __init__(self, dummyatt='', valueOf_=''):
        self.dummyatt = dummyatt
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if dummy1.subclass:
            return dummy1.subclass(*args_, **kwargs_)
        else:
            return dummy1(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_dummyatt(self): return self.dummyatt
    def set_dummyatt(self, dummyatt): self.dummyatt = dummyatt
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='dummy1'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='dummy1')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='dummy1'):
        outfile.write(' dummyatt="%s"' % (quote_attrib(self.get_dummyatt()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='dummy1'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='dummy1'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('dummyatt = "%s",\n' % (self.get_dummyatt(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('dummyatt'):
            self.dummyatt = attrs.get('dummyatt').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class dummy1


class applyTo(object):
    subclass = None
    superclass = None
    def __init__(self, interfaceRef=None):
        if interfaceRef is None:
            self.interfaceRef = []
        else:
            self.interfaceRef = interfaceRef
    def factory(*args_, **kwargs_):
        if applyTo.subclass:
            return applyTo.subclass(*args_, **kwargs_)
        else:
            return applyTo(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_interfaceRef(self): return self.interfaceRef
    def set_interfaceRef(self, interfaceRef): self.interfaceRef = interfaceRef
    def add_interfaceRef(self, value): self.interfaceRef.append(value)
    def insert_interfaceRef(self, index, value): self.interfaceRef[index] = value
    def validate_interfaceRef(self, value):
        # validate type interfaceRef
        pass
    def export(self, outfile, level, namespace_='', name_='applyTo'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='applyTo')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='applyTo'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='applyTo'):
        for interfaceRef_ in self.get_interfaceRef():
            interfaceRef_.export(outfile, level, namespace_, name_='interfaceRef')
    def exportLiteral(self, outfile, level, name_='applyTo'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('interfaceRef=[\n')
        level += 1
        for interfaceRef in self.interfaceRef:
            showIndent(outfile, level)
            outfile.write('interfaceRef(\n')
            interfaceRef.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'interfaceRef':
            obj_ = interfaceRef.factory()
            obj_.build(child_)
            self.interfaceRef.append(obj_)
            self.validate_interfaceRef(self.interfaceRef)    # validate type interfaceRef
# end class applyTo


class dummy2(object):
    subclass = None
    superclass = None
    def __init__(self, dummyatt2='', valueOf_=''):
        self.dummyatt2 = dummyatt2
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if dummy2.subclass:
            return dummy2.subclass(*args_, **kwargs_)
        else:
            return dummy2(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_dummyatt2(self): return self.dummyatt2
    def set_dummyatt2(self, dummyatt2): self.dummyatt2 = dummyatt2
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='dummy2'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='dummy2')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='dummy2'):
        outfile.write(' dummyatt2="%s"' % (quote_attrib(self.get_dummyatt2()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='dummy2'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='dummy2'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('dummyatt2 = "%s",\n' % (self.get_dummyatt2(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('dummyatt2'):
            self.dummyatt2 = attrs.get('dummyatt2').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class dummy2


class applyToFasConfig(object):
    subclass = None
    superclass = None
    def __init__(self, applyTo=None):
        self.applyTo = applyTo
    def factory(*args_, **kwargs_):
        if applyToFasConfig.subclass:
            return applyToFasConfig.subclass(*args_, **kwargs_)
        else:
            return applyToFasConfig(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_applyTo(self): return self.applyTo
    def set_applyTo(self, applyTo): self.applyTo = applyTo
    def export(self, outfile, level, namespace_='', name_='applyToFasConfig'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='applyToFasConfig')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='applyToFasConfig'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='applyToFasConfig'):
        if self.applyTo:
            self.applyTo.export(outfile, level, namespace_, name_='applyTo', )
    def exportLiteral(self, outfile, level, name_='applyToFasConfig'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.applyTo:
            showIndent(outfile, level)
            outfile.write('applyTo=applyTo(\n')
            self.applyTo.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'applyTo':
            obj_ = applyTo.factory()
            obj_.build(child_)
            self.set_applyTo(obj_)
# end class applyToFasConfig


class dummy3(object):
    subclass = None
    superclass = None
    def __init__(self, dummyatt3='', valueOf_=''):
        self.dummyatt3 = dummyatt3
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if dummy3.subclass:
            return dummy3.subclass(*args_, **kwargs_)
        else:
            return dummy3(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_dummyatt3(self): return self.dummyatt3
    def set_dummyatt3(self, dummyatt3): self.dummyatt3 = dummyatt3
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='dummy3'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='dummy3')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='dummy3'):
        outfile.write(' dummyatt3="%s"' % (quote_attrib(self.get_dummyatt3()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='dummy3'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='dummy3'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('dummyatt3 = "%s",\n' % (self.get_dummyatt3(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('dummyatt3'):
            self.dummyatt3 = attrs.get('dummyatt3').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class dummy3


class nfasGroupMembers(object):
    subclass = None
    superclass = None
    def __init__(self, members=None):
        self.members = members
    def factory(*args_, **kwargs_):
        if nfasGroupMembers.subclass:
            return nfasGroupMembers.subclass(*args_, **kwargs_)
        else:
            return nfasGroupMembers(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_members(self): return self.members
    def set_members(self, members): self.members = members
    def export(self, outfile, level, namespace_='', name_='nfasGroupMembers'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='nfasGroupMembers')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='nfasGroupMembers'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='nfasGroupMembers'):
        if self.members:
            self.members.export(outfile, level, namespace_, name_='members', )
    def exportLiteral(self, outfile, level, name_='nfasGroupMembers'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.members:
            showIndent(outfile, level)
            outfile.write('members=members(\n')
            self.members.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'members':
            obj_ = members.factory()
            obj_.build(child_)
            self.set_members(obj_)
# end class nfasGroupMembers


class members(object):
    subclass = None
    superclass = None
    def __init__(self, interfaceRef=None):
        if interfaceRef is None:
            self.interfaceRef = []
        else:
            self.interfaceRef = interfaceRef
    def factory(*args_, **kwargs_):
        if members.subclass:
            return members.subclass(*args_, **kwargs_)
        else:
            return members(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_interfaceRef(self): return self.interfaceRef
    def set_interfaceRef(self, interfaceRef): self.interfaceRef = interfaceRef
    def add_interfaceRef(self, value): self.interfaceRef.append(value)
    def insert_interfaceRef(self, index, value): self.interfaceRef[index] = value
    def validate_interfaceRef(self, value):
        # validate type interfaceRef
        pass
    def export(self, outfile, level, namespace_='', name_='members'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='members')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='members'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='members'):
        for interfaceRef_ in self.get_interfaceRef():
            interfaceRef_.export(outfile, level, namespace_, name_='interfaceRef')
    def exportLiteral(self, outfile, level, name_='members'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('interfaceRef=[\n')
        level += 1
        for interfaceRef in self.interfaceRef:
            showIndent(outfile, level)
            outfile.write('interfaceRef(\n')
            interfaceRef.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'interfaceRef':
            obj_ = interfaceRef.factory()
            obj_.build(child_)
            self.interfaceRef.append(obj_)
            self.validate_interfaceRef(self.interfaceRef)    # validate type interfaceRef
# end class members


class dummy4(object):
    subclass = None
    superclass = None
    def __init__(self, dummyatt4='', valueOf_=''):
        self.dummyatt4 = dummyatt4
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if dummy4.subclass:
            return dummy4.subclass(*args_, **kwargs_)
        else:
            return dummy4(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_dummyatt4(self): return self.dummyatt4
    def set_dummyatt4(self, dummyatt4): self.dummyatt4 = dummyatt4
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='dummy4'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='dummy4')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='dummy4'):
        outfile.write(' dummyatt4="%s"' % (quote_attrib(self.get_dummyatt4()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='dummy4'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='dummy4'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('dummyatt4 = "%s",\n' % (self.get_dummyatt4(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('dummyatt4'):
            self.dummyatt4 = attrs.get('dummyatt4').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class dummy4


class analog(object):
    subclass = None
    superclass = None
    def __init__(self, variant=None, analogFxoConfig=None, analogFxsConfig=None):
        self.variant = variant
        if analogFxoConfig is None:
            self.analogFxoConfig = []
        else:
            self.analogFxoConfig = analogFxoConfig
        if analogFxsConfig is None:
            self.analogFxsConfig = []
        else:
            self.analogFxsConfig = analogFxsConfig
    def factory(*args_, **kwargs_):
        if analog.subclass:
            return analog.subclass(*args_, **kwargs_)
        else:
            return analog(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_analogFxoConfig(self): return self.analogFxoConfig
    def set_analogFxoConfig(self, analogFxoConfig): self.analogFxoConfig = analogFxoConfig
    def add_analogFxoConfig(self, value): self.analogFxoConfig.append(value)
    def insert_analogFxoConfig(self, index, value): self.analogFxoConfig[index] = value
    def get_analogFxsConfig(self): return self.analogFxsConfig
    def set_analogFxsConfig(self, analogFxsConfig): self.analogFxsConfig = analogFxsConfig
    def add_analogFxsConfig(self, value): self.analogFxsConfig.append(value)
    def insert_analogFxsConfig(self, index, value): self.analogFxsConfig[index] = value
    def get_variant(self): return self.variant
    def set_variant(self, variant): self.variant = variant
    def export(self, outfile, level, namespace_='', name_='analog'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='analog')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='analog'):
        if self.get_variant() is not None:
            outfile.write(' variant="%s"' % str(self.get_variant()))
    def exportChildren(self, outfile, level, namespace_='', name_='analog'):
        for analogFxoConfig_ in self.get_analogFxoConfig():
            analogFxoConfig_.export(outfile, level, namespace_, name_='analogFxoConfig')
        for analogFxsConfig_ in self.get_analogFxsConfig():
            analogFxsConfig_.export(outfile, level, namespace_, name_='analogFxsConfig')
    def exportLiteral(self, outfile, level, name_='analog'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('variant = "%s",\n' % (self.get_variant(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('analogFxoConfig=[\n')
        level += 1
        for analogFxoConfig in self.analogFxoConfig:
            showIndent(outfile, level)
            outfile.write('analogFxoConfig(\n')
            analogFxoConfig.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('analogFxsConfig=[\n')
        level += 1
        for analogFxsConfig in self.analogFxsConfig:
            showIndent(outfile, level)
            outfile.write('analogFxsConfig(\n')
            analogFxsConfig.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('variant'):
            self.variant = attrs.get('variant').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'analogFxoConfig':
            obj_ = analogFxoConfig.factory()
            obj_.build(child_)
            self.analogFxoConfig.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'analogFxsConfig':
            obj_ = analogFxsConfig.factory()
            obj_.build(child_)
            self.analogFxsConfig.append(obj_)
# end class analog


class connect(object):
    subclass = None
    superclass = None
    def __init__(self, delayInMs=None, condition=None, valueOf_=''):
        self.delayInMs = delayInMs
        self.condition = condition
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if connect.subclass:
            return connect.subclass(*args_, **kwargs_)
        else:
            return connect(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_delayInMs(self): return self.delayInMs
    def set_delayInMs(self, delayInMs): self.delayInMs = delayInMs
    def get_condition(self): return self.condition
    def set_condition(self, condition): self.condition = condition
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='connect'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='connect')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='connect'):
        if self.get_delayInMs() is not None:
            outfile.write(' delayInMs="%d"' % self.get_delayInMs())
        if self.get_condition() is not None:
            outfile.write(' condition="%s"' % (quote_attrib(self.get_condition()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='connect'):
        outfile.write(quote_xml('%s' % self.valueOf_))
    def exportLiteral(self, outfile, level, name_='connect'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('delayInMs = "%s",\n' % (self.get_delayInMs(),))
        showIndent(outfile, level)
        outfile.write('condition = "%s",\n' % (self.get_condition(),))
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('delayInMs'):
            try:
                self.delayInMs = int(attrs.get('delayInMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (delayInMs): %s' % exp)
            if self.delayInMs < 0:
                raise ValueError('Invalid NonNegativeInteger (delayInMs)')
        if attrs.get('condition'):
            self.condition = attrs.get('condition').value
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
# end class connect


class nfasGroup(nfasGroupMembers):
    subclass = None
    superclass = nfasGroupMembers
    def __init__(self, members=None, switchVariant='', displayName='', initiateRestartProcedure=None, BChannelNegotiation='', waitFacilityDelayMs=None, inbandProgressTonesIndicator=None, callerNameLocation=None, termination='', inbandProgressTonesGeneration=None, ID=1, valueOf_=''):
        nfasGroupMembers.__init__(self, members)
        self.switchVariant = switchVariant
        self.displayName = displayName
        self.initiateRestartProcedure = initiateRestartProcedure
        self.BChannelNegotiation = BChannelNegotiation
        self.waitFacilityDelayMs = waitFacilityDelayMs
        self.inbandProgressTonesIndicator = inbandProgressTonesIndicator
        self.callerNameLocation = callerNameLocation
        self.termination = termination
        self.inbandProgressTonesGeneration = inbandProgressTonesGeneration
        self.ID = ID
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if nfasGroup.subclass:
            return nfasGroup.subclass(*args_, **kwargs_)
        else:
            return nfasGroup(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_switchVariant(self): return self.switchVariant
    def set_switchVariant(self, switchVariant): self.switchVariant = switchVariant
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    def get_initiateRestartProcedure(self): return self.initiateRestartProcedure
    def set_initiateRestartProcedure(self, initiateRestartProcedure): self.initiateRestartProcedure = initiateRestartProcedure
    def get_BChannelNegotiation(self): return self.BChannelNegotiation
    def set_BChannelNegotiation(self, BChannelNegotiation): self.BChannelNegotiation = BChannelNegotiation
    def get_waitFacilityDelayMs(self): return self.waitFacilityDelayMs
    def set_waitFacilityDelayMs(self, waitFacilityDelayMs): self.waitFacilityDelayMs = waitFacilityDelayMs
    def get_inbandProgressTonesIndicator(self): return self.inbandProgressTonesIndicator
    def set_inbandProgressTonesIndicator(self, inbandProgressTonesIndicator): self.inbandProgressTonesIndicator = inbandProgressTonesIndicator
    def get_callerNameLocation(self): return self.callerNameLocation
    def set_callerNameLocation(self, callerNameLocation): self.callerNameLocation = callerNameLocation
    def get_termination(self): return self.termination
    def set_termination(self, termination): self.termination = termination
    def get_inbandProgressTonesGeneration(self): return self.inbandProgressTonesGeneration
    def set_inbandProgressTonesGeneration(self, inbandProgressTonesGeneration): self.inbandProgressTonesGeneration = inbandProgressTonesGeneration
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='nfasGroup'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='nfasGroup')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='nfasGroup'):
        nfasGroupMembers.exportAttributes(self, outfile, level, namespace_, name_='nfasGroup')
        outfile.write(' switchVariant="%s"' % (quote_attrib(self.get_switchVariant()), ))
        outfile.write(' displayName="%s"' % (quote_attrib(self.get_displayName()), ))
        if self.get_initiateRestartProcedure() is not None:
            outfile.write(' initiateRestartProcedure="%s"' % (quote_attrib(self.get_initiateRestartProcedure()), ))
        outfile.write(' BChannelNegotiation="%s"' % (quote_attrib(self.get_BChannelNegotiation()), ))
        if self.get_waitFacilityDelayMs() is not None:
            outfile.write(' waitFacilityDelayMs="%d"' % self.get_waitFacilityDelayMs())
        if self.get_inbandProgressTonesIndicator() is not None:
            outfile.write(' inbandProgressTonesIndicator="%s"' % (quote_attrib(self.get_inbandProgressTonesIndicator()), ))
        if self.get_callerNameLocation() is not None:
            outfile.write(' callerNameLocation="%s"' % (quote_attrib(self.get_callerNameLocation()), ))
        outfile.write(' termination="%s"' % (quote_attrib(self.get_termination()), ))
        if self.get_inbandProgressTonesGeneration() is not None:
            outfile.write(' inbandProgressTonesGeneration="%s"' % (quote_attrib(self.get_inbandProgressTonesGeneration()), ))
        outfile.write(' ID="%d"' % self.get_ID())
    def exportChildren(self, outfile, level, namespace_='', name_='nfasGroup'):
        nfasGroupMembers.exportChildren(self, outfile, level, namespace_, name_)
    def exportLiteral(self, outfile, level, name_='nfasGroup'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('switchVariant = "%s",\n' % (self.get_switchVariant(),))
        showIndent(outfile, level)
        outfile.write('displayName = "%s",\n' % (self.get_displayName(),))
        showIndent(outfile, level)
        outfile.write('initiateRestartProcedure = "%s",\n' % (self.get_initiateRestartProcedure(),))
        showIndent(outfile, level)
        outfile.write('BChannelNegotiation = "%s",\n' % (self.get_BChannelNegotiation(),))
        showIndent(outfile, level)
        outfile.write('waitFacilityDelayMs = "%s",\n' % (self.get_waitFacilityDelayMs(),))
        showIndent(outfile, level)
        outfile.write('inbandProgressTonesIndicator = "%s",\n' % (self.get_inbandProgressTonesIndicator(),))
        showIndent(outfile, level)
        outfile.write('callerNameLocation = "%s",\n' % (self.get_callerNameLocation(),))
        showIndent(outfile, level)
        outfile.write('termination = "%s",\n' % (self.get_termination(),))
        showIndent(outfile, level)
        outfile.write('inbandProgressTonesGeneration = "%s",\n' % (self.get_inbandProgressTonesGeneration(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
        nfasGroupMembers.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        nfasGroupMembers.exportLiteralChildren(self, outfile, level, name_)
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('switchVariant'):
            self.switchVariant = attrs.get('switchVariant').value
        if attrs.get('displayName'):
            self.displayName = attrs.get('displayName').value
        if attrs.get('initiateRestartProcedure'):
            self.initiateRestartProcedure = attrs.get('initiateRestartProcedure').value
        if attrs.get('BChannelNegotiation'):
            self.BChannelNegotiation = attrs.get('BChannelNegotiation').value
        if attrs.get('waitFacilityDelayMs'):
            try:
                self.waitFacilityDelayMs = int(attrs.get('waitFacilityDelayMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (waitFacilityDelayMs): %s' % exp)
            if self.waitFacilityDelayMs < 0:
                raise ValueError('Invalid NonNegativeInteger (waitFacilityDelayMs)')
        if attrs.get('inbandProgressTonesIndicator'):
            self.inbandProgressTonesIndicator = attrs.get('inbandProgressTonesIndicator').value
        if attrs.get('callerNameLocation'):
            self.callerNameLocation = attrs.get('callerNameLocation').value
        if attrs.get('termination'):
            self.termination = attrs.get('termination').value
        if attrs.get('inbandProgressTonesGeneration'):
            self.inbandProgressTonesGeneration = attrs.get('inbandProgressTonesGeneration').value
        if attrs.get('ID'):
            try:
                self.ID = int(attrs.get('ID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ID): %s' % exp)
            if self.ID <= 0:
                raise ValueError('Invalid PositiveInteger (ID)')
        nfasGroupMembers.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        nfasGroupMembers.buildChildren(self, child_, nodeName_)
# end class nfasGroup


class fasConfig(applyToFasConfig):
    subclass = None
    superclass = applyToFasConfig
    def __init__(self, applyTo=None, switchVariant='', displayName='', initiateRestartProcedure=None, BChannelNegotiation='', waitFacilityDelayMs=None, inbandProgressTonesIndicator=None, callerNameLocation=None, termination='', inbandProgressTonesGeneration=None, ID=1, valueOf_=''):
        applyToFasConfig.__init__(self, applyTo)
        self.switchVariant = switchVariant
        self.displayName = displayName
        self.initiateRestartProcedure = initiateRestartProcedure
        self.BChannelNegotiation = BChannelNegotiation
        self.waitFacilityDelayMs = waitFacilityDelayMs
        self.inbandProgressTonesIndicator = inbandProgressTonesIndicator
        self.callerNameLocation = callerNameLocation
        self.termination = termination
        self.inbandProgressTonesGeneration = inbandProgressTonesGeneration
        self.ID = ID
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if fasConfig.subclass:
            return fasConfig.subclass(*args_, **kwargs_)
        else:
            return fasConfig(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_switchVariant(self): return self.switchVariant
    def set_switchVariant(self, switchVariant): self.switchVariant = switchVariant
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    def get_initiateRestartProcedure(self): return self.initiateRestartProcedure
    def set_initiateRestartProcedure(self, initiateRestartProcedure): self.initiateRestartProcedure = initiateRestartProcedure
    def get_BChannelNegotiation(self): return self.BChannelNegotiation
    def set_BChannelNegotiation(self, BChannelNegotiation): self.BChannelNegotiation = BChannelNegotiation
    def get_waitFacilityDelayMs(self): return self.waitFacilityDelayMs
    def set_waitFacilityDelayMs(self, waitFacilityDelayMs): self.waitFacilityDelayMs = waitFacilityDelayMs
    def get_inbandProgressTonesIndicator(self): return self.inbandProgressTonesIndicator
    def set_inbandProgressTonesIndicator(self, inbandProgressTonesIndicator): self.inbandProgressTonesIndicator = inbandProgressTonesIndicator
    def get_callerNameLocation(self): return self.callerNameLocation
    def set_callerNameLocation(self, callerNameLocation): self.callerNameLocation = callerNameLocation
    def get_termination(self): return self.termination
    def set_termination(self, termination): self.termination = termination
    def get_inbandProgressTonesGeneration(self): return self.inbandProgressTonesGeneration
    def set_inbandProgressTonesGeneration(self, inbandProgressTonesGeneration): self.inbandProgressTonesGeneration = inbandProgressTonesGeneration
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='fasConfig'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='fasConfig')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='fasConfig'):
        applyToFasConfig.exportAttributes(self, outfile, level, namespace_, name_='fasConfig')
        outfile.write(' switchVariant="%s"' % (quote_attrib(self.get_switchVariant()), ))
        outfile.write(' displayName="%s"' % (quote_attrib(self.get_displayName()), ))
        if self.get_initiateRestartProcedure() is not None:
            outfile.write(' initiateRestartProcedure="%s"' % (quote_attrib(self.get_initiateRestartProcedure()), ))
        outfile.write(' BChannelNegotiation="%s"' % (quote_attrib(self.get_BChannelNegotiation()), ))
        if self.get_waitFacilityDelayMs() is not None:
            outfile.write(' waitFacilityDelayMs="%d"' % self.get_waitFacilityDelayMs())
        if self.get_inbandProgressTonesIndicator() is not None:
            outfile.write(' inbandProgressTonesIndicator="%s"' % (quote_attrib(self.get_inbandProgressTonesIndicator()), ))
        if self.get_callerNameLocation() is not None:
            outfile.write(' callerNameLocation="%s"' % (quote_attrib(self.get_callerNameLocation()), ))
        outfile.write(' termination="%s"' % (quote_attrib(self.get_termination()), ))
        if self.get_inbandProgressTonesGeneration() is not None:
            outfile.write(' inbandProgressTonesGeneration="%s"' % (quote_attrib(self.get_inbandProgressTonesGeneration()), ))
        outfile.write(' ID="%d"' % self.get_ID())
    def exportChildren(self, outfile, level, namespace_='', name_='fasConfig'):
        applyToFasConfig.exportChildren(self, outfile, level, namespace_, name_)
    def exportLiteral(self, outfile, level, name_='fasConfig'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('switchVariant = "%s",\n' % (self.get_switchVariant(),))
        showIndent(outfile, level)
        outfile.write('displayName = "%s",\n' % (self.get_displayName(),))
        showIndent(outfile, level)
        outfile.write('initiateRestartProcedure = "%s",\n' % (self.get_initiateRestartProcedure(),))
        showIndent(outfile, level)
        outfile.write('BChannelNegotiation = "%s",\n' % (self.get_BChannelNegotiation(),))
        showIndent(outfile, level)
        outfile.write('waitFacilityDelayMs = "%s",\n' % (self.get_waitFacilityDelayMs(),))
        showIndent(outfile, level)
        outfile.write('inbandProgressTonesIndicator = "%s",\n' % (self.get_inbandProgressTonesIndicator(),))
        showIndent(outfile, level)
        outfile.write('callerNameLocation = "%s",\n' % (self.get_callerNameLocation(),))
        showIndent(outfile, level)
        outfile.write('termination = "%s",\n' % (self.get_termination(),))
        showIndent(outfile, level)
        outfile.write('inbandProgressTonesGeneration = "%s",\n' % (self.get_inbandProgressTonesGeneration(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
        applyToFasConfig.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        applyToFasConfig.exportLiteralChildren(self, outfile, level, name_)
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('switchVariant'):
            self.switchVariant = attrs.get('switchVariant').value
        if attrs.get('displayName'):
            self.displayName = attrs.get('displayName').value
        if attrs.get('initiateRestartProcedure'):
            self.initiateRestartProcedure = attrs.get('initiateRestartProcedure').value
        if attrs.get('BChannelNegotiation'):
            self.BChannelNegotiation = attrs.get('BChannelNegotiation').value
        if attrs.get('waitFacilityDelayMs'):
            try:
                self.waitFacilityDelayMs = int(attrs.get('waitFacilityDelayMs').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (waitFacilityDelayMs): %s' % exp)
            if self.waitFacilityDelayMs < 0:
                raise ValueError('Invalid NonNegativeInteger (waitFacilityDelayMs)')
        if attrs.get('inbandProgressTonesIndicator'):
            self.inbandProgressTonesIndicator = attrs.get('inbandProgressTonesIndicator').value
        if attrs.get('callerNameLocation'):
            self.callerNameLocation = attrs.get('callerNameLocation').value
        if attrs.get('termination'):
            self.termination = attrs.get('termination').value
        if attrs.get('inbandProgressTonesGeneration'):
            self.inbandProgressTonesGeneration = attrs.get('inbandProgressTonesGeneration').value
        if attrs.get('ID'):
            try:
                self.ID = int(attrs.get('ID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ID): %s' % exp)
            if self.ID <= 0:
                raise ValueError('Invalid PositiveInteger (ID)')
        applyToFasConfig.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        applyToFasConfig.buildChildren(self, child_, nodeName_)
# end class fasConfig


class audio(VqeParameters):
    subclass = None
    superclass = VqeParameters
    def __init__(self, EchoCancellation=None, AcousticEchoCancellation=None, LevelControl=None, BackgroundNoiseAttenuation=None, DTMFRemoval=None, voicePacketLengthInMs='', toneSetName=None, defaultPcmLaw='', valueOf_=''):
        VqeParameters.__init__(self, EchoCancellation, AcousticEchoCancellation, LevelControl, BackgroundNoiseAttenuation, DTMFRemoval)
        self.voicePacketLengthInMs = voicePacketLengthInMs
        self.toneSetName = toneSetName
        self.defaultPcmLaw = defaultPcmLaw
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if audio.subclass:
            return audio.subclass(*args_, **kwargs_)
        else:
            return audio(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_voicePacketLengthInMs(self): return self.voicePacketLengthInMs
    def set_voicePacketLengthInMs(self, voicePacketLengthInMs): self.voicePacketLengthInMs = voicePacketLengthInMs
    def get_toneSetName(self): return self.toneSetName
    def set_toneSetName(self, toneSetName): self.toneSetName = toneSetName
    def get_defaultPcmLaw(self): return self.defaultPcmLaw
    def set_defaultPcmLaw(self, defaultPcmLaw): self.defaultPcmLaw = defaultPcmLaw
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='audio'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='audio')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='audio'):
        VqeParameters.exportAttributes(self, outfile, level, namespace_, name_='audio')
        outfile.write(' voicePacketLengthInMs="%s"' % (quote_attrib(self.get_voicePacketLengthInMs()), ))
        outfile.write(' toneSetName="%s"' % str(self.get_toneSetName()))
        outfile.write(' defaultPcmLaw="%s"' % (quote_attrib(self.get_defaultPcmLaw()), ))
    def exportChildren(self, outfile, level, namespace_='', name_='audio'):
        VqeParameters.exportChildren(self, outfile, level, namespace_, name_)
    def exportLiteral(self, outfile, level, name_='audio'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('voicePacketLengthInMs = "%s",\n' % (self.get_voicePacketLengthInMs(),))
        showIndent(outfile, level)
        outfile.write('toneSetName = "%s",\n' % (self.get_toneSetName(),))
        showIndent(outfile, level)
        outfile.write('defaultPcmLaw = "%s",\n' % (self.get_defaultPcmLaw(),))
        VqeParameters.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        VqeParameters.exportLiteralChildren(self, outfile, level, name_)
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('voicePacketLengthInMs'):
            self.voicePacketLengthInMs = attrs.get('voicePacketLengthInMs').value
        if attrs.get('toneSetName'):
            self.toneSetName = attrs.get('toneSetName').value
        if attrs.get('defaultPcmLaw'):
            self.defaultPcmLaw = attrs.get('defaultPcmLaw').value
        VqeParameters.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        VqeParameters.buildChildren(self, child_, nodeName_)
# end class audio


class sangomaAnalogBoard(sangomaAnalogInterfaces):
    subclass = None
    superclass = sangomaAnalogInterfaces
    def __init__(self, interface=None, wanpipe=1, model='', displayName='', ID=1, valueOf_=''):
        sangomaAnalogInterfaces.__init__(self, interface)
        self.wanpipe = wanpipe
        self.model = model
        self.displayName = displayName
        self.ID = ID
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if sangomaAnalogBoard.subclass:
            return sangomaAnalogBoard.subclass(*args_, **kwargs_)
        else:
            return sangomaAnalogBoard(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_wanpipe(self): return self.wanpipe
    def set_wanpipe(self, wanpipe): self.wanpipe = wanpipe
    def get_model(self): return self.model
    def set_model(self, model): self.model = model
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='sangomaAnalogBoard'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='sangomaAnalogBoard')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='sangomaAnalogBoard'):
        sangomaAnalogInterfaces.exportAttributes(self, outfile, level, namespace_, name_='sangomaAnalogBoard')
        outfile.write(' wanpipe="%d"' % self.get_wanpipe())
        outfile.write(' model="%s"' % (quote_attrib(self.get_model()), ))
        outfile.write(' displayName="%s"' % (quote_attrib(self.get_displayName()), ))
        outfile.write(' ID="%d"' % self.get_ID())
    def exportChildren(self, outfile, level, namespace_='', name_='sangomaAnalogBoard'):
        sangomaAnalogInterfaces.exportChildren(self, outfile, level, namespace_, name_)
    def exportLiteral(self, outfile, level, name_='sangomaAnalogBoard'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('wanpipe = "%s",\n' % (self.get_wanpipe(),))
        showIndent(outfile, level)
        outfile.write('model = "%s",\n' % (self.get_model(),))
        showIndent(outfile, level)
        outfile.write('displayName = "%s",\n' % (self.get_displayName(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
        sangomaAnalogInterfaces.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        sangomaAnalogInterfaces.exportLiteralChildren(self, outfile, level, name_)
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('wanpipe'):
            try:
                self.wanpipe = int(attrs.get('wanpipe').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (wanpipe): %s' % exp)
            if self.wanpipe <= 0:
                raise ValueError('Invalid PositiveInteger (wanpipe)')
        if attrs.get('model'):
            self.model = attrs.get('model').value
        if attrs.get('displayName'):
            self.displayName = attrs.get('displayName').value
        if attrs.get('ID'):
            try:
                self.ID = int(attrs.get('ID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ID): %s' % exp)
            if self.ID <= 0:
                raise ValueError('Invalid PositiveInteger (ID)')
        sangomaAnalogInterfaces.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        sangomaAnalogInterfaces.buildChildren(self, child_, nodeName_)
# end class sangomaAnalogBoard


class sangomaVirtualDigitalBoard(sangomaVirtualDigitalInterfaces):
    subclass = None
    superclass = sangomaVirtualDigitalInterfaces
    def __init__(self, interface=None, model='', displayName='', ID=1, valueOf_=''):
        sangomaVirtualDigitalInterfaces.__init__(self, interface)
        self.model = model
        self.displayName = displayName
        self.ID = ID
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if sangomaVirtualDigitalBoard.subclass:
            return sangomaVirtualDigitalBoard.subclass(*args_, **kwargs_)
        else:
            return sangomaVirtualDigitalBoard(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_model(self): return self.model
    def set_model(self, model): self.model = model
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='sangomaVirtualDigitalBoard'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='sangomaVirtualDigitalBoard')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='sangomaVirtualDigitalBoard'):
        sangomaVirtualDigitalInterfaces.exportAttributes(self, outfile, level, namespace_, name_='sangomaVirtualDigitalBoard')
        outfile.write(' model="%s"' % (quote_attrib(self.get_model()), ))
        outfile.write(' displayName="%s"' % (quote_attrib(self.get_displayName()), ))
        outfile.write(' ID="%d"' % self.get_ID())
    def exportChildren(self, outfile, level, namespace_='', name_='sangomaVirtualDigitalBoard'):
        sangomaVirtualDigitalInterfaces.exportChildren(self, outfile, level, namespace_, name_)
    def exportLiteral(self, outfile, level, name_='sangomaVirtualDigitalBoard'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('model = "%s",\n' % (self.get_model(),))
        showIndent(outfile, level)
        outfile.write('displayName = "%s",\n' % (self.get_displayName(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
        sangomaVirtualDigitalInterfaces.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        sangomaVirtualDigitalInterfaces.exportLiteralChildren(self, outfile, level, name_)
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('model'):
            self.model = attrs.get('model').value
        if attrs.get('displayName'):
            self.displayName = attrs.get('displayName').value
        if attrs.get('ID'):
            try:
                self.ID = int(attrs.get('ID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ID): %s' % exp)
            if self.ID <= 0:
                raise ValueError('Invalid PositiveInteger (ID)')
        sangomaVirtualDigitalInterfaces.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        sangomaVirtualDigitalInterfaces.buildChildren(self, child_, nodeName_)
# end class sangomaVirtualDigitalBoard


class sangomaDigitalBoard(sangomaDigitalInterfaces):
    subclass = None
    superclass = sangomaDigitalInterfaces
    def __init__(self, interface=None, model='', displayName='', ID=1, valueOf_=''):
        sangomaDigitalInterfaces.__init__(self, interface)
        self.model = model
        self.displayName = displayName
        self.ID = ID
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if sangomaDigitalBoard.subclass:
            return sangomaDigitalBoard.subclass(*args_, **kwargs_)
        else:
            return sangomaDigitalBoard(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_model(self): return self.model
    def set_model(self, model): self.model = model
    def get_displayName(self): return self.displayName
    def set_displayName(self, displayName): self.displayName = displayName
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='sangomaDigitalBoard'):
        showIndent(outfile, level)
        outfile.write('<%s%s' % (namespace_, name_))
        self.exportAttributes(outfile, level, namespace_, name_='sangomaDigitalBoard')
        outfile.write('>\n')
        self.exportChildren(outfile, level + 1, namespace_, name_)
        showIndent(outfile, level)
        outfile.write('</%s%s>\n' % (namespace_, name_))
    def exportAttributes(self, outfile, level, namespace_='', name_='sangomaDigitalBoard'):
        sangomaDigitalInterfaces.exportAttributes(self, outfile, level, namespace_, name_='sangomaDigitalBoard')
        outfile.write(' model="%s"' % (quote_attrib(self.get_model()), ))
        outfile.write(' displayName="%s"' % (quote_attrib(self.get_displayName()), ))
        outfile.write(' ID="%d"' % self.get_ID())
    def exportChildren(self, outfile, level, namespace_='', name_='sangomaDigitalBoard'):
        sangomaDigitalInterfaces.exportChildren(self, outfile, level, namespace_, name_)
    def exportLiteral(self, outfile, level, name_='sangomaDigitalBoard'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('model = "%s",\n' % (self.get_model(),))
        showIndent(outfile, level)
        outfile.write('displayName = "%s",\n' % (self.get_displayName(),))
        showIndent(outfile, level)
        outfile.write('ID = "%s",\n' % (self.get_ID(),))
        sangomaDigitalInterfaces.exportLiteralAttributes(self, outfile, level, name_)
    def exportLiteralChildren(self, outfile, level, name_):
        sangomaDigitalInterfaces.exportLiteralChildren(self, outfile, level, name_)
        showIndent(outfile, level)
        outfile.write('valueOf_ = "%s",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        if attrs.get('model'):
            self.model = attrs.get('model').value
        if attrs.get('displayName'):
            self.displayName = attrs.get('displayName').value
        if attrs.get('ID'):
            try:
                self.ID = int(attrs.get('ID').value)
            except ValueError, exp:
                raise ValueError('Bad integer attribute (ID): %s' % exp)
            if self.ID <= 0:
                raise ValueError('Invalid PositiveInteger (ID)')
        sangomaDigitalInterfaces.buildAttributes(self, attrs)
    def buildChildren(self, child_, nodeName_):
        sangomaDigitalInterfaces.buildChildren(self, child_, nodeName_)
# end class sangomaDigitalBoard


from xml.sax import handler, make_parser

class SaxStackElement:
    def __init__(self, name='', obj=None):
        self.name = name
        self.obj = obj
        self.content = ''

#
# SAX handler
#
class Sax_pstnConfigHandler(handler.ContentHandler):
    def __init__(self):
        self.stack = []
        self.root = None

    def getRoot(self):
        return self.root

    def setDocumentLocator(self, locator):
        self.locator = locator
    
    def showError(self, msg):
        print '*** (showError):', msg
        sys.exit(-1)

    def startElement(self, name, attrs):
        done = 0
        if name == 'pstnConfig':
            obj = pstnConfig.factory()
            stackObj = SaxStackElement('pstnConfig', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'providers':
            obj = providers.factory()
            stackObj = SaxStackElement('providers', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'boards':
            obj = boards.factory()
            stackObj = SaxStackElement('boards', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'physicalInterfaceConfigs':
            obj = physicalInterfaceConfigs.factory()
            stackObj = SaxStackElement('physicalInterfaceConfigs', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'callControl':
            obj = callControl.factory()
            stackObj = SaxStackElement('callControl', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'sangoma':
            obj = sangoma.factory()
            stackObj = SaxStackElement('sangoma', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'sangomaDigitalBoard':
            obj = sangomaDigitalBoard.factory()
            val = attrs.get('model', None)
            if val is not None:
                obj.set_model(val)
            val = attrs.get('displayName', None)
            if val is not None:
                obj.set_displayName(val)
            val = attrs.get('ID', None)
            if val is not None:
                obj.set_ID(val)
            stackObj = SaxStackElement('sangomaDigitalBoard', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'sangomaAnalogBoard':
            obj = sangomaAnalogBoard.factory()
            val = attrs.get('wanpipe', None)
            if val is not None:
                obj.set_wanpipe(val)
            val = attrs.get('model', None)
            if val is not None:
                obj.set_model(val)
            val = attrs.get('displayName', None)
            if val is not None:
                obj.set_displayName(val)
            val = attrs.get('ID', None)
            if val is not None:
                obj.set_ID(val)
            stackObj = SaxStackElement('sangomaAnalogBoard', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'sangomaVirtualDigitalBoard':
            obj = sangomaVirtualDigitalBoard.factory()
            val = attrs.get('model', None)
            if val is not None:
                obj.set_model(val)
            val = attrs.get('displayName', None)
            if val is not None:
                obj.set_displayName(val)
            val = attrs.get('ID', None)
            if val is not None:
                obj.set_ID(val)
            stackObj = SaxStackElement('sangomaVirtualDigitalBoard', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'sangomaDigitalConfig':
            obj = sangomaDigitalConfig.factory()
            val = attrs.get('displayName', None)
            if val is not None:
                obj.set_displayName(val)
            val = attrs.get('ID', None)
            if val is not None:
                obj.set_ID(val)
            stackObj = SaxStackElement('sangomaDigitalConfig', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'sangomaAnalogConfig':
            obj = sangomaAnalogConfig.factory()
            val = attrs.get('displayName', None)
            if val is not None:
                obj.set_displayName(val)
            val = attrs.get('ID', None)
            if val is not None:
                obj.set_ID(val)
            stackObj = SaxStackElement('sangomaAnalogConfig', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'channelGroups':
            obj = channelGroups.factory()
            stackObj = SaxStackElement('channelGroups', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'isdn':
            obj = isdn.factory()
            stackObj = SaxStackElement('isdn', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'analog':
            obj = analog.factory()
            val = attrs.get('variant', None)
            if val is not None:
                obj.set_variant(val)
            stackObj = SaxStackElement('analog', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'channelGroup':
            obj = channelGroup.factory()
            val = attrs.get('outboundHuntingScheme', None)
            if val is not None:
                obj.set_outboundHuntingScheme(val)
            val = attrs.get('direction', None)
            if val is not None:
                obj.set_direction(val)
            val = attrs.get('ID', None)
            if val is not None:
                obj.set_ID(val)
            stackObj = SaxStackElement('channelGroup', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'fasConfig':
            obj = fasConfig.factory()
            val = attrs.get('switchVariant', None)
            if val is not None:
                obj.set_switchVariant(val)
            val = attrs.get('displayName', None)
            if val is not None:
                obj.set_displayName(val)
            val = attrs.get('initiateRestartProcedure', None)
            if val is not None:
                obj.set_initiateRestartProcedure(val)
            val = attrs.get('BChannelNegotiation', None)
            if val is not None:
                obj.set_BChannelNegotiation(val)
            val = attrs.get('waitFacilityDelayMs', None)
            if val is not None:
                obj.set_waitFacilityDelayMs(val)
            val = attrs.get('inbandProgressTonesIndicator', None)
            if val is not None:
                obj.set_inbandProgressTonesIndicator(val)
            val = attrs.get('callerNameLocation', None)
            if val is not None:
                obj.set_callerNameLocation(val)
            val = attrs.get('termination', None)
            if val is not None:
                obj.set_termination(val)
            val = attrs.get('inbandProgressTonesGeneration', None)
            if val is not None:
                obj.set_inbandProgressTonesGeneration(val)
            val = attrs.get('ID', None)
            if val is not None:
                obj.set_ID(val)
            stackObj = SaxStackElement('fasConfig', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'nfasGroup':
            obj = nfasGroup.factory()
            val = attrs.get('switchVariant', None)
            if val is not None:
                obj.set_switchVariant(val)
            val = attrs.get('displayName', None)
            if val is not None:
                obj.set_displayName(val)
            val = attrs.get('initiateRestartProcedure', None)
            if val is not None:
                obj.set_initiateRestartProcedure(val)
            val = attrs.get('BChannelNegotiation', None)
            if val is not None:
                obj.set_BChannelNegotiation(val)
            val = attrs.get('waitFacilityDelayMs', None)
            if val is not None:
                obj.set_waitFacilityDelayMs(val)
            val = attrs.get('inbandProgressTonesIndicator', None)
            if val is not None:
                obj.set_inbandProgressTonesIndicator(val)
            val = attrs.get('callerNameLocation', None)
            if val is not None:
                obj.set_callerNameLocation(val)
            val = attrs.get('termination', None)
            if val is not None:
                obj.set_termination(val)
            val = attrs.get('inbandProgressTonesGeneration', None)
            if val is not None:
                obj.set_inbandProgressTonesGeneration(val)
            val = attrs.get('ID', None)
            if val is not None:
                obj.set_ID(val)
            stackObj = SaxStackElement('nfasGroup', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'BChannelsThreads':
            obj = BChannelsThreads.factory()
            val = attrs.get('count', None)
            if val is not None:
                obj.set_count(val)
            val = attrs.get('priority', None)
            if val is not None:
                obj.set_priority(val)
            stackObj = SaxStackElement('BChannelsThreads', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'DChannelsThreads':
            obj = DChannelsThreads.factory()
            val = attrs.get('count', None)
            if val is not None:
                obj.set_count(val)
            val = attrs.get('priority', None)
            if val is not None:
                obj.set_priority(val)
            stackObj = SaxStackElement('DChannelsThreads', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'TxMediaStreams':
            obj = TxMediaStreams.factory()
            val = attrs.get('reverseBits', None)
            if val is not None:
                obj.set_reverseBits(val)
            stackObj = SaxStackElement('TxMediaStreams', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'RxMediaStreams':
            obj = RxMediaStreams.factory()
            val = attrs.get('reverseBits', None)
            if val is not None:
                obj.set_reverseBits(val)
            stackObj = SaxStackElement('RxMediaStreams', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'digitalT1':
            obj = digitalT1.factory()
            val = attrs.get('loopbackMode', None)
            if val is not None:
                obj.set_loopbackMode(val)
            val = attrs.get('clocking', None)
            if val is not None:
                obj.set_clocking(val)
            val = attrs.get('framing', None)
            if val is not None:
                obj.set_framing(val)
            val = attrs.get('LBO', None)
            if val is not None:
                obj.set_LBO(val)
            val = attrs.get('lineEncoding', None)
            if val is not None:
                obj.set_lineEncoding(val)
            stackObj = SaxStackElement('digitalT1', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'digitalE1':
            obj = digitalE1.factory()
            val = attrs.get('E1Termination', None)
            if val is not None:
                obj.set_E1Termination(val)
            val = attrs.get('lineEncoding', None)
            if val is not None:
                obj.set_lineEncoding(val)
            val = attrs.get('clocking', None)
            if val is not None:
                obj.set_clocking(val)
            val = attrs.get('loopbackMode', None)
            if val is not None:
                obj.set_loopbackMode(val)
            val = attrs.get('framing', None)
            if val is not None:
                obj.set_framing(val)
            val = attrs.get('E1Signaling', None)
            if val is not None:
                obj.set_E1Signaling(val)
            stackObj = SaxStackElement('digitalE1', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'audio':
            obj = audio.factory()
            val = attrs.get('voicePacketLengthInMs', None)
            if val is not None:
                obj.set_voicePacketLengthInMs(val)
            val = attrs.get('toneSetName', None)
            if val is not None:
                obj.set_toneSetName(val)
            val = attrs.get('defaultPcmLaw', None)
            if val is not None:
                obj.set_defaultPcmLaw(val)
            stackObj = SaxStackElement('audio', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'applyTo':
            obj = applyTo.factory()
            stackObj = SaxStackElement('applyTo', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'DChannelT1':
            obj = DChannelT1.factory()
            val = attrs.get('mtuSize', None)
            if val is not None:
                obj.set_mtuSize(val)
            val = attrs.get('channelIndex', None)
            if val is not None:
                obj.set_channelIndex(val)
            stackObj = SaxStackElement('DChannelT1', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'DChannelE1':
            obj = DChannelE1.factory()
            val = attrs.get('mtuSize', None)
            if val is not None:
                obj.set_mtuSize(val)
            val = attrs.get('channelIndex', None)
            if val is not None:
                obj.set_channelIndex(val)
            stackObj = SaxStackElement('DChannelE1', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'EchoCancellation':
            obj = EchoCancellation.factory()
            val = attrs.get('doubleTalkBehavior', None)
            if val is not None:
                obj.set_doubleTalkBehavior(val)
            val = attrs.get('tailDisplacementInMs', None)
            if val is not None:
                obj.set_tailDisplacementInMs(val)
            val = attrs.get('type', None)
            if val is not None:
                obj.set_type(val)
            val = attrs.get('mode', None)
            if val is not None:
                obj.set_mode(val)
            val = attrs.get('comfortNoiseMode', None)
            if val is not None:
                obj.set_comfortNoiseMode(val)
            stackObj = SaxStackElement('EchoCancellation', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'AcousticEchoCancellation':
            obj = AcousticEchoCancellation.factory()
            val = attrs.get('type', None)
            if val is not None:
                obj.set_type(val)
            val = attrs.get('mode', None)
            if val is not None:
                obj.set_mode(val)
            stackObj = SaxStackElement('AcousticEchoCancellation', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'LevelControl':
            obj = LevelControl.factory()
            val = attrs.get('gainIndB', None)
            if val is not None:
                obj.set_gainIndB(val)
            val = attrs.get('direction', None)
            if val is not None:
                obj.set_direction(val)
            val = attrs.get('type', None)
            if val is not None:
                obj.set_type(val)
            val = attrs.get('mode', None)
            if val is not None:
                obj.set_mode(val)
            val = attrs.get('targetLevelIndBM0', None)
            if val is not None:
                obj.set_targetLevelIndBM0(val)
            stackObj = SaxStackElement('LevelControl', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'BackgroundNoiseAttenuation':
            obj = BackgroundNoiseAttenuation.factory()
            val = attrs.get('attenuationIndB', None)
            if val is not None:
                obj.set_attenuationIndB(val)
            val = attrs.get('direction', None)
            if val is not None:
                obj.set_direction(val)
            val = attrs.get('type', None)
            if val is not None:
                obj.set_type(val)
            val = attrs.get('mode', None)
            if val is not None:
                obj.set_mode(val)
            stackObj = SaxStackElement('BackgroundNoiseAttenuation', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'DTMFRemoval':
            obj = DTMFRemoval.factory()
            val = attrs.get('direction', None)
            if val is not None:
                obj.set_direction(val)
            val = attrs.get('type', None)
            if val is not None:
                obj.set_type(val)
            val = attrs.get('mode', None)
            if val is not None:
                obj.set_mode(val)
            stackObj = SaxStackElement('DTMFRemoval', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'inboundCallHandling':
            obj = inboundCallHandling.factory()
            stackObj = SaxStackElement('inboundCallHandling', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'outboundCallHandling':
            obj = outboundCallHandling.factory()
            stackObj = SaxStackElement('outboundCallHandling', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'disconnectSupervision':
            obj = disconnectSupervision.factory()
            stackObj = SaxStackElement('disconnectSupervision', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'notifyOutboundSide':
            obj = notifyOutboundSide.factory()
            val = attrs.get('numberOfRings', None)
            if val is not None:
                obj.set_numberOfRings(val)
            val = attrs.get('delayInMs', None)
            if val is not None:
                obj.set_delayInMs(val)
            val = attrs.get('condition', None)
            if val is not None:
                obj.set_condition(val)
            stackObj = SaxStackElement('notifyOutboundSide', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'connect':
            obj = connect.factory()
            val = attrs.get('delayInMs', None)
            if val is not None:
                obj.set_delayInMs(val)
            val = attrs.get('condition', None)
            if val is not None:
                obj.set_condition(val)
            stackObj = SaxStackElement('connect', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'callerID':
            obj = callerID.factory()
            val = attrs.get('type', None)
            if val is not None:
                obj.set_type(val)
            stackObj = SaxStackElement('callerID', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'dial':
            obj = dial.factory()
            val = attrs.get('active', None)
            if val is not None:
                obj.set_active(val)
            val = attrs.get('DTMFDigitDurationInMs', None)
            if val is not None:
                obj.set_DTMFDigitDurationInMs(val)
            val = attrs.get('interDigitDelayInMs', None)
            if val is not None:
                obj.set_interDigitDelayInMs(val)
            val = attrs.get('waitForDialTone', None)
            if val is not None:
                obj.set_waitForDialTone(val)
            val = attrs.get('preDialDelayInMs', None)
            if val is not None:
                obj.set_preDialDelayInMs(val)
            stackObj = SaxStackElement('dial', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'connectSupervision':
            obj = connectSupervision.factory()
            stackObj = SaxStackElement('connectSupervision', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'connectOutboundSide':
            obj = connectOutboundSide.factory()
            val = attrs.get('disconnectTimeoutMs', None)
            if val is not None:
                obj.set_disconnectTimeoutMs(val)
            val = attrs.get('condition', None)
            if val is not None:
                obj.set_condition(val)
            val = attrs.get('connectOnNoRemoteRingTimeoutMs', None)
            if val is not None:
                obj.set_connectOnNoRemoteRingTimeoutMs(val)
            stackObj = SaxStackElement('connectOutboundSide', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'disconnectDetectors':
            obj = disconnectDetectors.factory()
            stackObj = SaxStackElement('disconnectDetectors', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'ringCadenceDetector':
            obj = ringCadenceDetector.factory()
            val = attrs.get('active', None)
            if val is not None:
                obj.set_active(val)
            val = attrs.get('ringCadenceOffDelayMs', None)
            if val is not None:
                obj.set_ringCadenceOffDelayMs(val)
            stackObj = SaxStackElement('ringCadenceDetector', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'detector':
            obj = detector.factory()
            val = attrs.get('name', None)
            if val is not None:
                obj.set_name(val)
            val = attrs.get('sequence', None)
            if val is not None:
                obj.set_sequence(val)
            stackObj = SaxStackElement('detector', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'interface':
            obj = interface.factory()
            val = attrs.get('displayName', None)
            if val is not None:
                obj.set_displayName(val)
            val = attrs.get('peerVirtualInterfaceID', None)
            if val is not None:
                obj.set_peerVirtualInterfaceID(val)
            val = attrs.get('wanpipe', None)
            if val is not None:
                obj.set_wanpipe(val)
            val = attrs.get('peerVirtualBoardID', None)
            if val is not None:
                obj.set_peerVirtualBoardID(val)
            val = attrs.get('wanpipeInterface', None)
            if val is not None:
                obj.set_wanpipeInterface(val)
            val = attrs.get('primaryClockReference', None)
            if val is not None:
                obj.set_primaryClockReference(val)
            val = attrs.get('type', None)
            if val is not None:
                obj.set_type(val)
            val = attrs.get('ID', None)
            if val is not None:
                obj.set_ID(val)
            stackObj = SaxStackElement('interface', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'BChannelRange':
            obj = BChannelRange.factory()
            stackObj = SaxStackElement('BChannelRange', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'interfaceRef':
            obj = interfaceRef.factory()
            stackObj = SaxStackElement('interfaceRef', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'members':
            obj = members.factory()
            stackObj = SaxStackElement('members', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'analogFxoConfig':
            obj = analogFxoConfig.factory()
            stackObj = SaxStackElement('analogFxoConfig', obj)
            self.stack.append(stackObj)
            done = 1
        elif name == 'analogFxsConfig':
            obj = analogFxsConfig.factory()
            stackObj = SaxStackElement('analogFxsConfig', obj)
            self.stack.append(stackObj)
            done = 1
        if not done:
            self.reportError('"%s" element not allowed here.' % name)

    def endElement(self, name):
        done = 0
        if name == 'pstnConfig':
            if len(self.stack) == 1:
                self.root = self.stack[-1].obj
                self.stack.pop()
                done = 1
        elif name == 'providers':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_providers(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'boards':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_boards(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'physicalInterfaceConfigs':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_physicalInterfaceConfigs(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'callControl':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_callControl(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'sangoma':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_sangoma(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'sangomaDigitalBoard':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_sangomaDigitalBoard(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'sangomaAnalogBoard':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_sangomaAnalogBoard(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'sangomaVirtualDigitalBoard':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_sangomaVirtualDigitalBoard(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'sangomaDigitalConfig':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_sangomaDigitalConfig(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'sangomaAnalogConfig':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_sangomaAnalogConfig(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'channelGroups':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_channelGroups(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'isdn':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_isdn(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'analog':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_analog(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'channelGroup':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_channelGroup(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'fasConfig':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_fasConfig(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'nfasGroup':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_nfasGroup(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'BChannelsThreads':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_BChannelsThreads(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'DChannelsThreads':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_DChannelsThreads(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'TxMediaStreams':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_TxMediaStreams(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'RxMediaStreams':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_RxMediaStreams(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'digitalT1':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_digitalT1(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'digitalE1':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_digitalE1(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'audio':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_audio(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'applyTo':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_applyTo(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'DChannelT1':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_DChannelT1(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'DChannelE1':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_DChannelE1(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'EchoCancellation':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_EchoCancellation(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'AcousticEchoCancellation':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_AcousticEchoCancellation(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'LevelControl':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_LevelControl(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'BackgroundNoiseAttenuation':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_BackgroundNoiseAttenuation(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'DTMFRemoval':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_DTMFRemoval(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'inboundCallHandling':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_inboundCallHandling(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'outboundCallHandling':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_outboundCallHandling(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'disconnectSupervision':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_disconnectSupervision(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'notifyOutboundSide':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_notifyOutboundSide(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'connect':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_connect(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'callerID':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_callerID(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'dial':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_dial(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'connectSupervision':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_connectSupervision(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'connectOutboundSide':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_connectOutboundSide(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'disconnectDetectors':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_disconnectDetectors(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'ringCadenceDetector':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_ringCadenceDetector(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'detector':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_detector(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'interface':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_interface(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'BChannelRange':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_BChannelRange(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'interfaceRef':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_interfaceRef(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'members':
            if len(self.stack) >= 2:
                self.stack[-2].obj.set_members(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'analogFxoConfig':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_analogFxoConfig(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        elif name == 'analogFxsConfig':
            if len(self.stack) >= 2:
                self.stack[-2].obj.add_analogFxsConfig(self.stack[-1].obj)
                self.stack.pop()
                done = 1
        if not done:
            self.reportError('"%s" element not allowed here.' % name)

    def characters(self, chrs, start, end):
        if len(self.stack) > 0:
            self.stack[-1].content += chrs[start:end]

    def reportError(self, mesg):
        locator = self.locator
        sys.stderr.write('Doc: %s  Line: %d  Column: %d\n' % \
            (locator.getSystemId(), locator.getLineNumber(), 
            locator.getColumnNumber() + 1))
        sys.stderr.write(mesg)
        sys.stderr.write('\n')
        sys.exit(-1)
        #raise RuntimeError

USAGE_TEXT = """
Usage: python <Parser>.py [ -s ] <in_xml_file>
Options:
    -s        Use the SAX parser, not the minidom parser.
"""

def usage():
    print USAGE_TEXT
    sys.exit(-1)


#
# SAX handler used to determine the top level element.
#
class SaxSelectorHandler(handler.ContentHandler):
    def __init__(self):
        self.topElementName = None
    def getTopElementName(self):
        return self.topElementName
    def startElement(self, name, attrs):
        self.topElementName = name
        raise StopIteration


def parseSelect(inFileName):
    infile = file(inFileName, 'r')
    topElementName = None
    parser = make_parser()
    documentHandler = SaxSelectorHandler()
    parser.setContentHandler(documentHandler)
    try:
        try:
            parser.parse(infile)
        except StopIteration:
            topElementName = documentHandler.getTopElementName()
        if topElementName is None:
            raise RuntimeError, 'no top level element'
        topElementName = topElementName.replace('-', '_').replace(':', '_')
        if topElementName not in globals():
            raise RuntimeError, 'no class for top element: %s' % topElementName
        topElement = globals()[topElementName]
        infile.seek(0)
        doc = minidom.parse(infile)
    finally:
        infile.close()
    rootNode = doc.childNodes[0]
    rootObj = topElement.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    return rootObj


def saxParse(inFileName):
    parser = make_parser()
    documentHandler = Sax_pstnConfigHandler()
    parser.setDocumentHandler(documentHandler)
    parser.parse('file:%s' % inFileName)
    root = documentHandler.getRoot()
    return root


def saxParseString(inString):
    parser = make_parser()
    documentHandler = Sax_pstnConfigHandler()
    parser.setDocumentHandler(documentHandler)
    parser.feed(inString)
    parser.close()
    rootObj = documentHandler.getRoot()
    return rootObj


def parse(inFileName):
    doc = minidom.parse(inFileName)
    rootNode = doc.documentElement
    rootObj = pstnConfig.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    return rootObj


def parseString(inString):
    doc = minidom.parseString(inString)
    rootNode = doc.documentElement
    rootObj = pstnConfig.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    return rootObj


def parseLiteral(inFileName):
    doc = minidom.parse(inFileName)
    rootNode = doc.documentElement
    rootObj = pstnConfig.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    sys.stdout.write('from pstnconfig import *\n\n')
    sys.stdout.write('rootObj = pstnConfig(\n')
    rootObj.exportLiteral(sys.stdout, 0, name_="pstnConfig")
    sys.stdout.write(')\n')
    return rootObj


def main():
    args = sys.argv[1:]
    if len(args) == 2 and args[0] == '-s':
        sys.stdout.write('<?xml version="1.0" ?>\n')
        saxParse(args[1]).export(sys.stdout, 0, name_="pstnConfig")
    elif len(args) == 1:
        sys.stdout.write('<?xml version="1.0" ?>\n')
        parse(args[0]).export(sys.stdout, 0, name_="pstnConfig")
    else:
        usage()


if __name__ == '__main__':
    main()
    #import pdb
    #pdb.run('main()')

